import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { AnimateType } from 'ngx-weui/core';
import { AccordionConfig } from './accordion.config';
export declare class AccordionComponent {
    /**
     * 是否可折叠，`true` 表示同时所有都允许展开，`false` 表示同时只允许一个展开，默认：`false`
     */
    collapsible: boolean;
    /**
     * 自动展开第一次，默认：`true`
     */
    activeFirst: boolean;
    /**
     * 动画类型，`none` 无动画，`slide` 滑动，默认：`slide`
     */
    _animate: AnimateType;
    /**
     * 展开时回调，参数为面板下标。
     */
    readonly select: EventEmitter<number>;
    private panels;
    constructor(config: AccordionConfig);
    _add(item: AccordionPanelComponent): void;
    _remove(item: AccordionPanelComponent): void;
    _index(item: AccordionPanelComponent): number;
    _closeOthers(cur: AccordionPanelComponent): void;
}
export declare class AccordionPanelComponent implements OnInit, OnDestroy {
    protected accordion: AccordionComponent;
    /**
     * 是否禁止
     */
    disabled: boolean;
    private _active;
    /**
     * 是否展开
     */
    get active(): boolean;
    set active(value: boolean);
    constructor(accordion: AccordionComponent);
    ngOnInit(): void;
    ngOnDestroy(): void;
    _toggle(): void;
}
