import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { ActionSheetConfig } from './actionsheet.config';
import { ActionSheetMenuItem } from './actionsheet.types';
export declare class ActionSheetComponent implements OnDestroy {
    private DEF;
    private cdr;
    private observer;
    private destroied;
    _shown: boolean;
    /**
     * 动画状态码
     */
    _shownAnt: boolean;
    /**
     * 配置项
     */
    config: ActionSheetConfig;
    /**
     * 菜单内容
     */
    menus: ActionSheetMenuItem[];
    /**
     * 关闭回调
     */
    readonly close: EventEmitter<any>;
    get _visibility(): string;
    constructor(DEF: ActionSheetConfig, cdr: ChangeDetectorRef);
    private detectChanges;
    /**
     * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
     */
    show(): Observable<ActionSheetMenuItem>;
    /**
     * 隐藏
     *
     * @param is_backdrop 是否从背景上点击
     */
    hide(is_backdrop?: boolean): void;
    /**
     * 选择动作
     */
    _onSelect(menu: ActionSheetMenuItem): void;
    ngOnDestroy(): void;
}
