import { ApplicationRef, ComponentFactoryResolver, Injector } from '@angular/core';
import { BaseService } from 'ngx-weui/core';
import { Observable } from 'rxjs';
import { ActionSheetConfig } from './actionsheet.config';
import { ActionSheetMenuItem } from './actionsheet.types';
export declare class ActionSheetService extends BaseService {
    protected readonly resolver: ComponentFactoryResolver;
    protected readonly applicationRef: ApplicationRef;
    protected readonly injector: Injector;
    protected readonly doc: any;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    /**
     * 创建一个弹出式菜单并显示
     *
     * @param menus 菜单内容
     * @param config 配置性（可选）
     * @returns 可订阅来获取结果
     */
    show(menus: ActionSheetMenuItem[], config?: ActionSheetConfig): Observable<ActionSheetMenuItem>;
}
