/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/core', ['exports', '@angular/common', '@angular/core', '@angular/platform-browser'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].core = {}), global.ng.common, global.ng.core, global.ng.platformBrowser));
}(this, (function (exports, i1, i0, platformBrowser) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/loader.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoaderService = /** @class */ (function () {
        /**
         * @param {?} doc
         */
        function LoaderService(doc) {
            this.doc = doc;
            this.list = {};
        }
        /**
         * @param {?} paths
         * @return {?}
         */
        LoaderService.prototype.load = function (paths) {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                /** @type {?} */
                var promises = [];
                if (!Array.isArray(paths)) {
                    paths = [paths];
                }
                (( /** @type {?} */(paths))).forEach(( /**
                 * @param {?} path
                 * @return {?}
                 */function (/**
                 * @param {?} path
                 * @return {?}
                 */ path) {
                    if (path.endsWith('.css')) {
                        promises.push(_this.loadCss(path));
                    }
                    else {
                        promises.push(_this.loadScript(path));
                    }
                }));
                Promise.all(promises)
                    .then(( /**
             * @return {?}
             */function () { return resolve(true); }))
                    .catch(( /**
             * @return {?}
             */function () { return resolve(false); }));
            }));
        };
        /**
         * @param {?} path
         * @return {?}
         */
        LoaderService.prototype.loadScript = function (path) {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                if (_this.list[path] === true) {
                    resolve(( /** @type {?} */({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                    return;
                }
                _this.list[path] = true;
                /** @type {?} */
                var node = _this.doc.createElement('script');
                node.type = 'text/javascript';
                node.src = path;
                node.charset = 'utf-8';
                node.defer = true;
                node.onload = ( /**
                 * @return {?}
                 */function () {
                    resolve(( /** @type {?} */({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                });
                node.onerror = ( /**
                 * @return {?}
                 */function () { return resolve(( /** @type {?} */({
                    path: path,
                    loaded: false,
                    status: 'Loaded',
                }))); });
                _this.doc.getElementsByTagName('head')[0].appendChild(node);
            }));
        };
        /**
         * @param {?} path
         * @return {?}
         */
        LoaderService.prototype.loadCss = function (path) {
            var _this = this;
            return new Promise(( /**
             * @param {?} resolve
             * @return {?}
             */function (/**
             * @param {?} resolve
             * @return {?}
             */ resolve) {
                if (_this.list[path] === true) {
                    resolve(( /** @type {?} */({
                        path: path,
                        loaded: true,
                        status: 'Loaded',
                    })));
                    return;
                }
                _this.list[path] = true;
                /** @type {?} */
                var node = _this.doc.createElement('link');
                node.rel = 'stylesheet';
                node.type = 'text/css';
                node.href = path;
                _this.doc.getElementsByTagName('head')[0].appendChild(node);
                resolve(( /** @type {?} */({
                    path: path,
                    loaded: true,
                    status: 'Loaded',
                })));
            }));
        };
        return LoaderService;
    }());
    LoaderService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    LoaderService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ LoaderService.ɵprov = i0.ɵɵdefineInjectable({ factory: function LoaderService_Factory() { return new LoaderService(i0.ɵɵinject(i1.DOCUMENT)); }, token: LoaderService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @private
         */
        LoaderService.prototype.list;
        /**
         * @type {?}
         * @private
         */
        LoaderService.prototype.doc;
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @abstract
     */
    var BaseService = /** @class */ (function () {
        function BaseService() {
            this.list = [];
        }
        /**
         * 销毁
         *
         * @param {?=} component 下标（从0开始或组件引用对象），或不指定时，销毁最新一个
         * @return {?}
         */
        BaseService.prototype.destroy = function (component) {
            if (typeof component === 'number') {
                component = this.list[( /** @type {?} */(component))];
            }
            if (!component) {
                component = this.list.pop();
            }
            if (component) {
                (( /** @type {?} */(component))).destroy();
            }
        };
        /**
         * 销毁所有
         * @return {?}
         */
        BaseService.prototype.destroyAll = function () {
            var e_1, _a;
            try {
                for (var _b = __values(this.list), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var component = _c.value;
                    this.destroy(component);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        /**
         * 动态构建组件
         * @protected
         * @template T
         * @param {?} component
         * @return {?}
         */
        BaseService.prototype.build = function (component) {
            var _this = this;
            /** @type {?} */
            var componentFactory = this.resolver.resolveComponentFactory(component);
            /** @type {?} */
            var componentRef = componentFactory.create(this.injector);
            this.list.push(componentRef);
            /** @type {?} */
            var componentRootNode = ( /** @type {?} */((( /** @type {?} */(componentRef.hostView))).rootNodes[0]));
            this.applicationRef.attachView(componentRef.hostView);
            componentRef.onDestroy(( /**
             * @return {?}
             */function () {
                _this.applicationRef.detachView(componentRef.hostView);
            }));
            this.doc.body.appendChild(componentRootNode);
            return componentRef;
        };
        return BaseService;
    }());
    BaseService.decorators = [
        { type: i0.Injectable }
    ];
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        BaseService.prototype.list;
        /**
         * @type {?}
         * @protected
         */
        BaseService.prototype.resolver;
        /**
         * @type {?}
         * @protected
         */
        BaseService.prototype.applicationRef;
        /**
         * @type {?}
         * @protected
         */
        BaseService.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        BaseService.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/dom.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 向上查找父节点
     * @param {?} el
     * @param {?} selector
     * @return {?}
     */
    function findParent(el, selector) {
        /** @type {?} */
        var retEl = null;
        while (el) {
            if (el.matches(selector)) {
                retEl = el;
                break;
            }
            el = el.parentElement;
        }
        return retEl;
    }
    /**
     * 查找并创建
     * @param {?} el
     * @param {?=} selector
     * @param {?=} tagName
     * @param {?=} className
     * @param {?=} cssText
     * @return {?}
     */
    function add(el, selector, tagName, className, cssText) {
        if (selector === void 0) { selector = '.weui-cell__ft'; }
        if (tagName === void 0) { tagName = 'div'; }
        if (className === void 0) { className = 'weui-cell__ft'; }
        if (cssText === void 0) { cssText = ''; }
        /** @type {?} */
        var ret = ( /** @type {?} */(el.querySelector(selector)));
        if (!ret) {
            ret = document.createElement(tagName);
            ret.className = className;
            if (cssText) {
                ret.style.cssText = cssText;
            }
            el.appendChild(ret);
        }
        return ret;
    }
    /**
     * 移除
     * @param {?} el
     * @param {?} selector
     * @return {?}
     */
    function remove(el, selector) {
        if (!el) {
            return;
        }
        /** @type {?} */
        var ret = el.querySelector(selector);
        if (ret) {
            el.removeChild(ret);
        }
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/browser.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 是否服务端渲染
     * @type {?}
     */
    var isSSR = !(typeof document === 'object' && !!document);
    /**
     * @param {?} type
     * @return {?}
     */
    function isPlatform(type) {
        /** @type {?} */
        var body = ( /** @type {?} */(platformBrowser.ɵgetDOM().getDefaultDocument().querySelector('body')));
        return body && body.getAttribute('data-platform') === type;
    }
    /**
     * 检查是否安卓系统
     * @return {?}
     */
    function isAndroid() {
        return isPlatform('android') ? true : /android (\d+)/.test(platformBrowser.ɵgetDOM().getUserAgent().toLowerCase());
    }
    /**
     * 检查是否IOS系统
     * @return {?}
     */
    function isIOS() {
        return isPlatform('ios') ? true : /iPad|iPhone|iPod/.test(platformBrowser.ɵgetDOM().getUserAgent());
    }
    /**
     * 检查File是否为图像文件
     * @param {?} file
     * @return {?}
     */
    function isImage(file) {
        if (isSSR && !(file instanceof window.File)) {
            return false;
        }
        /** @type {?} */
        var type = "|" + file.type.slice(file.type.lastIndexOf('/') + 1) + "|";
        return '|jpg|png|jpeg|bmp|gif|'.indexOf(type) !== -1;
    }
    /**
     * 生成可预览的图像地址
     * @param {?} file
     * @return {?}
     */
    function genImageUrl(file) {
        if (!isSSR && isImage(file)) {
            return window.URL.createObjectURL(file);
        }
        return '';
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/check.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} element
     * @return {?}
     */
    function isEmpty(element) {
        /** @type {?} */
        var nodes = element.childNodes;
        for (var i = 0; i < nodes.length; i++) {
            /** @type {?} */
            var node = nodes.item(i);
            if (node.nodeType === 1 && (( /** @type {?} */(node))).outerHTML.toString().trim().length !== 0) {
                return false;
            }
            else if (node.nodeType === 3 && ( /** @type {?} */(node.textContent)).toString().trim().length !== 0) {
                return false;
            }
        }
        return true;
    }
    /**
     * @param {?} value
     * @param {?=} allowUndefined
     * @return {?}
     */
    function toBoolean(value, allowUndefined) {
        if (allowUndefined === void 0) { allowUndefined = false; }
        return allowUndefined && typeof value === 'undefined' ? undefined : value != null && "" + value !== 'false';
    }
    /**
     * Input decorator that handle a prop to do get/set automatically with toBoolean
     * \@example
     * ```typescript
     * \@Input() \@InputBoolean() visible: boolean = false; / \@InputBoolean(null) visible: boolean = false;
     * ```
     * @param {?=} allowUndefined
     * @return {?}
     */
    function InputBoolean(allowUndefined) {
        if (allowUndefined === void 0) { allowUndefined = false; }
        return ( /**
         * @param {?} target
         * @param {?} name
         * @return {?}
         */function InputBooleanPropDecorator(target, name) {
            // Add our own private prop
            /** @type {?} */
            var privatePropName = "$$__" + name;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by InputBoolean decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true,
            });
            Object.defineProperty(target, name, {
                /**
                 * @return {?}
                 */
                get: function () {
                    return this[privatePropName]; // tslint:disable-line:no-invalid-this
                },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) {
                    this[privatePropName] = toBoolean(value, allowUndefined); // tslint:disable-line:no-invalid-this
                },
            });
        });
    }
    /**
     * @param {?} value
     * @param {?=} fallbackValue
     * @return {?}
     */
    function toNumber(value, fallbackValue) {
        if (fallbackValue === void 0) { fallbackValue = 0; }
        return !isNaN(parseFloat(( /** @type {?} */(value)))) && !isNaN(Number(value)) ? Number(value) : fallbackValue;
    }
    /**
     * Input decorator that handle a prop to do get/set automatically with toNumber
     * \@example
     * ```typescript
     * \@Input() \@InputNumber() visible: number = 1; / \@InputNumber(null) visible: number = 2;
     * ```
     * @param {?=} fallback
     * @return {?}
     */
    function InputNumber(fallback) {
        if (fallback === void 0) { fallback = 0; }
        return ( /**
         * @param {?} target
         * @param {?} name
         * @return {?}
         */function InputBooleanPropDecorator(target, name) {
            // Add our own private prop
            /** @type {?} */
            var privatePropName = "$$__" + name;
            if (Object.prototype.hasOwnProperty.call(target, privatePropName)) {
                console.warn("The prop \"" + privatePropName + "\" is already exist, it will be overrided by InputNumber decorator.");
            }
            Object.defineProperty(target, privatePropName, {
                configurable: true,
                writable: true,
            });
            Object.defineProperty(target, name, {
                /**
                 * @return {?}
                 */
                get: function () {
                    return this[privatePropName]; // tslint:disable-line:no-invalid-this
                },
                /**
                 * @param {?} value
                 * @return {?}
                 */
                set: function (value) {
                    this[privatePropName] = toNumber(value, fallback); // tslint:disable-line:no-invalid-this
                },
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: utils/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: addon/string_template_outlet.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var StringTemplateOutletDirective = /** @class */ (function () {
        /**
         * @param {?} viewContainer
         * @param {?} defaultTemplate
         */
        function StringTemplateOutletDirective(viewContainer, defaultTemplate) {
            this.viewContainer = viewContainer;
            this.defaultTemplate = defaultTemplate;
            this.inputTemplate = null;
            this.inputViewRef = null;
            this.defaultViewRef = null;
        }
        Object.defineProperty(StringTemplateOutletDirective.prototype, "stringTemplateOutlet", {
            /**
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                if (value instanceof i0.TemplateRef) {
                    this.isTemplate = true;
                    this.inputTemplate = value;
                }
                else {
                    this.isTemplate = false;
                }
                this.updateView();
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        StringTemplateOutletDirective.prototype.updateView = function () {
            if (!this.isTemplate) {
                // use default template when input is string
                if (!this.defaultViewRef) {
                    this.viewContainer.clear();
                    this.inputViewRef = null;
                    this.defaultViewRef = this.viewContainer.createEmbeddedView(this.defaultTemplate);
                }
            }
            else {
                // clear previous view if any.
                if (this.inputViewRef) {
                    this.inputViewRef = null;
                }
                // use input template when input is templateRef
                this.viewContainer.clear();
                this.defaultViewRef = null;
                this.inputViewRef = this.viewContainer.createEmbeddedView(( /** @type {?} */(this.inputTemplate)));
            }
        };
        return StringTemplateOutletDirective;
    }());
    StringTemplateOutletDirective.decorators = [
        { type: i0.Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[stringTemplateOutlet]',
                    exportAs: 'stringTemplateOutlet',
                },] }
    ];
    /** @nocollapse */
    StringTemplateOutletDirective.ctorParameters = function () { return [
        { type: i0.ViewContainerRef },
        { type: i0.TemplateRef }
    ]; };
    StringTemplateOutletDirective.propDecorators = {
        stringTemplateOutlet: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.isTemplate;
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.inputTemplate;
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.inputViewRef;
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.defaultViewRef;
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.viewContainer;
        /**
         * @type {?}
         * @private
         */
        StringTemplateOutletDirective.prototype.defaultTemplate;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: addon/addon.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddOnModule = /** @class */ (function () {
        function AddOnModule() {
        }
        return AddOnModule;
    }());
    AddOnModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [i1.CommonModule],
                    exports: [StringTemplateOutletDirective],
                    declarations: [StringTemplateOutletDirective],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: addon/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: services/update-host-class.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UpdateHostClassService = /** @class */ (function () {
        /**
         * @param {?} rendererFactory2
         */
        function UpdateHostClassService(rendererFactory2) {
            this.classMap = {};
            this.renderer = rendererFactory2.createRenderer(null, null);
        }
        /**
         * @param {?} el
         * @param {?} classMap
         * @return {?}
         */
        UpdateHostClassService.prototype.updateHostClass = function (el, classMap) {
            this.removeClass(el, this.classMap, this.renderer);
            this.classMap = Object.assign({}, classMap);
            this.addClass(el, this.classMap, this.renderer);
        };
        /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        UpdateHostClassService.prototype.removeClass = function (el, classMap, renderer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i)) {
                    renderer.removeClass(el, i);
                }
            }
        };
        /**
         * @private
         * @param {?} el
         * @param {?} classMap
         * @param {?} renderer
         * @return {?}
         */
        UpdateHostClassService.prototype.addClass = function (el, classMap, renderer) {
            for (var i in classMap) {
                if (classMap.hasOwnProperty(i) && classMap[i]) {
                    renderer.addClass(el, i);
                }
            }
        };
        return UpdateHostClassService;
    }());
    UpdateHostClassService.decorators = [
        { type: i0.Injectable }
    ];
    /** @nocollapse */
    UpdateHostClassService.ctorParameters = function () { return [
        { type: i0.RendererFactory2 }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        UpdateHostClassService.prototype.classMap;
        /**
         * @type {?}
         * @private
         */
        UpdateHostClassService.prototype.renderer;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: services/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /** @type {?} */
    var record = {};
    /** @type {?} */
    var PREFIX = '[NGX-WEUI]:';
    /**
     * @param {...?} args
     * @return {?}
     */
    function notRecorded() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        /** @type {?} */
        var asRecord = args.reduce(( /**
         * @param {?} acc
         * @param {?} c
         * @return {?}
         */function (acc, c) { return acc + c.toString(); }), '');
        if (record[asRecord]) {
            return false;
        }
        else {
            record[asRecord] = true;
            return true;
        }
    }
    /**
     * @param {?} consoleFunc
     * @param {...?} args
     * @return {?}
     */
    function consoleCommonBehavior(consoleFunc) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (i0.isDevMode() && notRecorded.apply(void 0, __spread(args))) {
            consoleFunc.apply(void 0, __spread(args));
        }
    }
    // Warning should only be printed in dev mode and only once.
    /** @type {?} */
    var warn = ( /**
     * @param {...?} args
     * @return {?}
     */function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return consoleCommonBehavior.apply(void 0, __spread([( /**
             * @param {...?} arg
             * @return {?}
             */function () {
                var arg = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    arg[_i] = arguments[_i];
                }
                return console.warn.apply(console, __spread([PREFIX], arg));
            })], args));
    });
    /** @type {?} */
    var deprecation10 = ( /**
     * @param {?} comp
     * @param {?} from
     * @param {?=} to
     * @return {?}
     */function (comp, from, to) {
        warnDeprecation(comp + " => '" + from + "' is going to be removed in 10.0.0" + (to ? ", Please use '" + to + "' instead" : "") + ".");
    });
    /** @type {?} */
    var warnDeprecation = ( /**
     * @param {...?} args
     * @return {?}
     */function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (i0.isDevMode()) {
            /** @type {?} */
            var stack_1 = new Error().stack;
            return consoleCommonBehavior.apply(void 0, __spread([( /**
                 * @param {...?} arg
                 * @return {?}
                 */function () {
                    var arg = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        arg[_i] = arguments[_i];
                    }
                    return console.warn.apply(console, __spread([PREFIX, 'deprecated:'], arg, [stack_1]));
                })], args));
        }
        else {
            return ( /**
             * @return {?}
             */function () { });
        }
    });
    // Log should only be printed in dev mode.
    /** @type {?} */
    var log = ( /**
     * @param {...?} args
     * @return {?}
     */function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (i0.isDevMode()) {
            console.log.apply(console, __spread([PREFIX], args));
        }
    });

    /**
     * @fileoverview added by tsickle
     * Generated from: logger/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-core.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AddOnModule = AddOnModule;
    exports.BaseService = BaseService;
    exports.InputBoolean = InputBoolean;
    exports.InputNumber = InputNumber;
    exports.LoaderService = LoaderService;
    exports.PREFIX = PREFIX;
    exports.StringTemplateOutletDirective = StringTemplateOutletDirective;
    exports.UpdateHostClassService = UpdateHostClassService;
    exports.add = add;
    exports.deprecation10 = deprecation10;
    exports.findParent = findParent;
    exports.genImageUrl = genImageUrl;
    exports.isAndroid = isAndroid;
    exports.isEmpty = isEmpty;
    exports.isIOS = isIOS;
    exports.isImage = isImage;
    exports.isPlatform = isPlatform;
    exports.isSSR = isSSR;
    exports.log = log;
    exports.remove = remove;
    exports.toBoolean = toBoolean;
    exports.toNumber = toNumber;
    exports.warn = warn;
    exports.warnDeprecation = warnDeprecation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-core.umd.js.map
