/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/infiniteloader', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].infiniteloader = {}), global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, i0, rxjs, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderConfig = /** @class */ (function () {
        function InfiniteLoaderConfig() {
            /**
             * 容器高度，默认：`100vh`
             */
            this.height = '100vh';
            /**
             * 滚动至x%时触发加载，默认：75%
             */
            this.percent = 75;
            /**
             * 加载中文本（支持HTML），默认：weui-loadmore 组件
             */
            this.loading = '<div class="weui-loadmore"><i class="weui-loading"></i><span class="weui-loadmore__tips">加载中…</span></div>';
            /**
             * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
             */
            this.finished = '<div class="weui-loadmore weui-loadmore_line"><span class="weui-loadmore__tips">已加载完毕</span></div>';
            /**
             * 滚动节流时长（单位：ms），默认：`100`
             */
            this.throttle = 100;
        }
        return InfiniteLoaderConfig;
    }());
    InfiniteLoaderConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ InfiniteLoaderConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function InfiniteLoaderConfig_Factory() { return new InfiniteLoaderConfig(); }, token: InfiniteLoaderConfig, providedIn: "root" });
    if (false) {
        /**
         * 容器高度，默认：`100vh`
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.height;
        /**
         * 滚动至x%时触发加载，默认：75%
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.percent;
        /**
         * 加载中文本（支持HTML），默认：weui-loadmore 组件
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.loading;
        /**
         * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.finished;
        /**
         * 滚动节流时长（单位：ms），默认：`100`
         * @type {?}
         */
        InfiniteLoaderConfig.prototype.throttle;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderComponent = /** @class */ (function () {
        /**
         * @param {?} el
         * @param {?} DEF
         * @param {?} cdr
         */
        function InfiniteLoaderComponent(el, DEF, cdr) {
            this.el = el;
            this.DEF = DEF;
            this.cdr = cdr;
            this.didScroll = false;
            this.scrollEvent = null;
            this.scrollTime = null;
            this._loading = false;
            this._finished = false;
            this._restart = false;
            this.loadmore = new i0.EventEmitter();
            this.config = Object.assign({}, DEF);
        }
        Object.defineProperty(InfiniteLoaderComponent.prototype, "config", {
            /**
             * @return {?}
             */
            get: function () {
                return this._config;
            },
            /**
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this._config = Object.assign(Object.assign({}, this.DEF), val);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * 设置本次加载完成
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.resolveLoading = function () {
            this._loading = false;
            this._finished = false;
            this.cdr.detectChanges();
        };
        /**
         * 设置结束
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.setFinished = function () {
            this._loading = false;
            this._finished = true;
            this.cdr.detectChanges();
        };
        /**
         * 设置重新开始
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.restart = function () {
            this._finished = false;
            this._restart = true;
            this.cdr.detectChanges();
        };
        /**
         * 触发滚动
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.scroll = function () {
            if (!this.scrollEvent || this._loading || this._finished) {
                return;
            }
            /** @type {?} */
            var target = ( /** @type {?} */(this.scrollEvent.target));
            if (this._restart) {
                target.scrollTop = 0;
                this._restart = false;
            }
            /** @type {?} */
            var scrollPercent = Math.floor(((target.scrollTop + target.clientHeight) / target.scrollHeight) * 100);
            if (scrollPercent > ( /** @type {?} */(this.config.percent))) {
                this._loading = true;
                this.loadmore.emit(this);
                this.cdr.detectChanges();
            }
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.scrollTime = setInterval(( /**
             * @return {?}
             */function () {
                if (_this.didScroll) {
                    _this.didScroll = false;
                    _this.scroll();
                }
            }), this.config.throttle);
            this.disposeScroller = rxjs.fromEvent(( /** @type {?} */(this.el.nativeElement.querySelector('.weui-infiniteloader__content'))), 'scroll').subscribe(( /**
             * @param {?} $event
             * @return {?}
             */function ($event) {
                _this.scrollEvent = $event;
                _this.didScroll = true;
            }));
        };
        /**
         * @return {?}
         */
        InfiniteLoaderComponent.prototype.ngOnDestroy = function () {
            if (this.scrollTime) {
                clearTimeout(this.scrollTime);
            }
            if (this.disposeScroller) {
                this.disposeScroller.unsubscribe();
            }
        };
        return InfiniteLoaderComponent;
    }());
    InfiniteLoaderComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-infiniteloader',
                    exportAs: 'weuiInfiniteloader',
                    template: "<div class=\"weui-infiniteloader__content\">\n  <ng-content></ng-content>\n  <div *ngIf=\"_loading || _finished\">\n    <div *ngIf=\"_loading\" [innerHTML]=\"config.loading!\"></div>\n    <div *ngIf=\"_finished\" [innerHTML]=\"config.finished!\"></div>\n  </div>\n</div>\n",
                    host: {
                        '[class.weui-infiniteloader]': 'true',
                        '[style.height]': 'config.height',
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    InfiniteLoaderComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: InfiniteLoaderConfig },
        { type: i0.ChangeDetectorRef }
    ]; };
    InfiniteLoaderComponent.propDecorators = {
        loadmore: [{ type: i0.Output }],
        config: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.didScroll;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.scrollEvent;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.scrollTime;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.disposeScroller;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._loading;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._finished;
        /** @type {?} */
        InfiniteLoaderComponent.prototype._restart;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype._config;
        /** @type {?} */
        InfiniteLoaderComponent.prototype.loadmore;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        InfiniteLoaderComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: infiniteloader.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InfiniteLoaderModule = /** @class */ (function () {
        function InfiniteLoaderModule() {
        }
        return InfiniteLoaderModule;
    }());
    InfiniteLoaderModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [InfiniteLoaderComponent],
                    exports: [InfiniteLoaderComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-infiniteloader.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.InfiniteLoaderComponent = InfiniteLoaderComponent;
    exports.InfiniteLoaderConfig = InfiniteLoaderConfig;
    exports.InfiniteLoaderModule = InfiniteLoaderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-infiniteloader.umd.js.map
