/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/loadmore', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].loadmore = {}), global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: loadmore.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadmoreConfig = /** @class */ (function () {
        function LoadmoreConfig() {
            /**
             * 类型，默认：`loading`
             */
            this.type = 'loading';
            /**
             * 当type=='loading'时显示的文本，默认：`正在加载`
             */
            this.loadingText = '正在加载';
            /**
             * 当type=='line'时显示的文本，默认：`暂无数据`
             */
            this.lineText = '暂无数据';
        }
        return LoadmoreConfig;
    }());
    LoadmoreConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ LoadmoreConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function LoadmoreConfig_Factory() { return new LoadmoreConfig(); }, token: LoadmoreConfig, providedIn: "root" });
    if (false) {
        /**
         * 类型，默认：`loading`
         * @type {?}
         */
        LoadmoreConfig.prototype.type;
        /**
         * 当type=='loading'时显示的文本，默认：`正在加载`
         * @type {?}
         */
        LoadmoreConfig.prototype.loadingText;
        /**
         * 当type=='line'时显示的文本，默认：`暂无数据`
         * @type {?}
         */
        LoadmoreConfig.prototype.lineText;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: loadmore.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadmoreComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         */
        function LoadmoreComponent(DEF) {
            /**
             * 类型，默认：`loading`
             */
            this.type = 'loading';
            /**
             * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
             */
            this.loadingText = '正在加载';
            /**
             * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
             */
            this.lineText = '暂无数据';
            Object.assign(this, DEF);
        }
        return LoadmoreComponent;
    }());
    LoadmoreComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-loadmore',
                    exportAs: 'weuiLoadmore',
                    template: "<div\n  class=\"weui-loadmore\"\n  [ngClass]=\"{\n    'weui-loadmore_line': type !== 'loading',\n    'weui-loadmore_dot': type === 'dot'\n  }\"\n>\n  <i class=\"weui-loading\" *ngIf=\"type === 'loading'\"></i>\n  <span class=\"weui-loadmore__tips\">{{ type === 'dot' ? '' : type === 'line' ? lineText : loadingText }}</span>\n</div>\n",
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    LoadmoreComponent.ctorParameters = function () { return [
        { type: LoadmoreConfig }
    ]; };
    LoadmoreComponent.propDecorators = {
        type: [{ type: i0.Input }],
        loadingText: [{ type: i0.Input }],
        lineText: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * 类型，默认：`loading`
         * @type {?}
         */
        LoadmoreComponent.prototype.type;
        /**
         * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
         * @type {?}
         */
        LoadmoreComponent.prototype.loadingText;
        /**
         * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
         * @type {?}
         */
        LoadmoreComponent.prototype.lineText;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: loadmore.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LoadmoreModule = /** @class */ (function () {
        function LoadmoreModule() {
        }
        return LoadmoreModule;
    }());
    LoadmoreModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [LoadmoreComponent],
                    exports: [LoadmoreComponent],
                    entryComponents: [LoadmoreComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-loadmore.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.LoadmoreComponent = LoadmoreComponent;
    exports.LoadmoreConfig = LoadmoreConfig;
    exports.LoadmoreModule = LoadmoreModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-loadmore.umd.js.map
