/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/popup', ['exports', '@angular/animations', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].popup = {}), global.ng.animations, global.ng.core, global.rxjs, global.ng.common));
}(this, (function (exports, animations, i0, rxjs, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: popup.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupConfig = /** @class */ (function () {
        function PopupConfig() {
            /**
             * 是否全屏，默认：`false`
             */
            this.is_full = false;
            /**
             * 取消按钮文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 确定按钮文本，默认：`确定`
             */
            this.confirm = '确定';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        return PopupConfig;
    }());
    PopupConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ PopupConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function PopupConfig_Factory() { return new PopupConfig(); }, token: PopupConfig, providedIn: "root" });
    if (false) {
        /**
         * 是否全屏，默认：`false`
         * @type {?}
         */
        PopupConfig.prototype.is_full;
        /**
         * 取消按钮文本，默认：`取消`
         * @type {?}
         */
        PopupConfig.prototype.cancel;
        /**
         * 确定按钮文本，默认：`确定`
         * @type {?}
         */
        PopupConfig.prototype.confirm;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        PopupConfig.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: popup.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         * @param {?} cdr
         */
        function PopupComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            this.shown = false;
            this._shownAnt = false;
            this.cancel = new i0.EventEmitter();
            this.confirm = new i0.EventEmitter();
            this.config = Object.assign({}, DEF);
        }
        Object.defineProperty(PopupComponent.prototype, "config", {
            /**
             * @return {?}
             */
            get: function () {
                return this._config;
            },
            /**
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this._config = Object.assign(Object.assign({}, this.DEF), val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PopupComponent.prototype, "_visibility", {
            /**
             * @return {?}
             */
            get: function () {
                return this._shownAnt ? 'show' : 'hide';
            },
            enumerable: false,
            configurable: true
        });
        /**
         * 显示，并支持订阅结果，如果点击取消值为false，反之 true
         * @return {?}
         */
        PopupComponent.prototype.show = function () {
            var _this = this;
            this.shown = true;
            setTimeout(( /**
             * @return {?}
             */function () {
                _this._shownAnt = true;
                _this.cdr.detectChanges();
            }), 10);
            return new rxjs.Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop
         * @return {?}
         */
        PopupComponent.prototype.hide = function (is_backdrop) {
            var _this = this;
            if (is_backdrop === true && this.config.backdrop === false) {
                return;
            }
            this._shownAnt = false;
            this.cdr.detectChanges();
            setTimeout(( /**
             * @return {?}
             */function () {
                _this.shown = false;
            }), 300);
        };
        /**
         * 关闭，等同 `hide()` 效果
         * @return {?}
         */
        PopupComponent.prototype.close = function () {
            this.hide(false);
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype._onCancel = function () {
            this.cancel.emit();
            this.hide(false);
            if (this.observer) {
                this.observer.next(false);
                this.observer.complete();
            }
            return false;
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype._onConfirm = function () {
            this.confirm.emit();
            this.hide(false);
            if (this.observer) {
                this.observer.next(true);
                this.observer.complete();
            }
            return false;
        };
        /**
         * @return {?}
         */
        PopupComponent.prototype.ngOnDestroy = function () {
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                this.observer.unsubscribe();
            }
        };
        return PopupComponent;
    }());
    PopupComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-popup',
                    exportAs: 'weuiPopup',
                    template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-popup\" [ngClass]=\"{ 'weui-popup_toggle': _shownAnt }\">\n  <div class=\"weui-popup__hd\" *ngIf=\"!config.is_full\">\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onCancel()\">{{ config.cancel }}</a>\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onConfirm()\">{{ config.confirm }}</a>\n  </div>\n  <div [ngClass]=\"{ 'weui-popup_full': config.is_full }\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                    animations: [
                        animations.trigger('visibility', [
                            animations.state('show', animations.style({ opacity: 1 })),
                            animations.state('hide', animations.style({ opacity: 0 })),
                            animations.transition('hide <=> show', [animations.animate(200)]),
                        ]),
                    ],
                    host: {
                        '[hidden]': '!shown',
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    PopupComponent.ctorParameters = function () { return [
        { type: PopupConfig },
        { type: i0.ChangeDetectorRef }
    ]; };
    PopupComponent.propDecorators = {
        cancel: [{ type: i0.Output }],
        confirm: [{ type: i0.Output }],
        config: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        PopupComponent.prototype.observer;
        /** @type {?} */
        PopupComponent.prototype.shown;
        /** @type {?} */
        PopupComponent.prototype._shownAnt;
        /**
         * @type {?}
         * @private
         */
        PopupComponent.prototype._config;
        /** @type {?} */
        PopupComponent.prototype.cancel;
        /** @type {?} */
        PopupComponent.prototype.confirm;
        /**
         * @type {?}
         * @private
         */
        PopupComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        PopupComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: popup.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PopupModule = /** @class */ (function () {
        function PopupModule() {
        }
        return PopupModule;
    }());
    PopupModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [PopupComponent],
                    exports: [PopupComponent],
                    entryComponents: [PopupComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-popup.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.PopupComponent = PopupComponent;
    exports.PopupConfig = PopupConfig;
    exports.PopupModule = PopupModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-popup.umd.js.map
