/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/swiper', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].swiper = {}), global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: swiper.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperConfig = /** @class */ (function () {
        function SwiperConfig() {
            /**
             * 等同于swiper[参数项](http://idangero.us/swiper/api/)
             */
            this.options = {
                loop: true,
                pagination: '.swiper-pagination',
            };
        }
        return SwiperConfig;
    }());
    SwiperConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ SwiperConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function SwiperConfig_Factory() { return new SwiperConfig(); }, token: SwiperConfig, providedIn: "root" });
    if (false) {
        /**
         * 等同于swiper[参数项](http://idangero.us/swiper/api/)
         * @type {?}
         */
        SwiperConfig.prototype.options;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: swiper.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperComponent = /** @class */ (function () {
        /**
         * @param {?} el
         * @param {?} zone
         * @param {?} DEF
         */
        function SwiperComponent(el, zone, DEF) {
            this.el = el;
            this.zone = zone;
            this.DEF = DEF;
        }
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.initOptions = function () {
            this.options = Object.assign(Object.assign({}, this.DEF.options), this.options);
        };
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.init = function () {
            var _this = this;
            this.destroy();
            this.zone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.swiper = new Swiper(_this.containerEl, _this.options);
            }));
        };
        /**
         * @private
         * @return {?}
         */
        SwiperComponent.prototype.destroy = function () {
            var _this = this;
            if (this.containerEl) {
                ['horizontal', 'vertical'].forEach(( /**
                 * @param {?} v
                 * @return {?}
                 */function (/**
                 * @param {?} v
                 * @return {?}
                 */ v) {
                    _this.containerEl.classList.remove('swiper-container-' + v);
                }));
            }
            if (this.swiper) {
                this.zone.runOutsideAngular(( /**
                 * @return {?}
                 */function () {
                    _this.swiper.destroy(true, false);
                    _this.swiper = null;
                }));
            }
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngOnInit = function () {
            if (!this.options) {
                this.initOptions();
            }
            this.containerEl = this.el.nativeElement.querySelector('.swiper-container');
            if (!this.containerEl) {
                throw new Error('组件内容的HTML跟swiper所需要的DOM结构必须完全一样。');
            }
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngAfterViewInit = function () {
            this.init();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        SwiperComponent.prototype.ngOnChanges = function (changes) {
            if (changes.options) {
                this.initOptions();
                if (!changes.options.firstChange) {
                    this.init();
                }
            }
        };
        /**
         * @return {?}
         */
        SwiperComponent.prototype.ngOnDestroy = function () {
            this.destroy();
        };
        return SwiperComponent;
    }());
    SwiperComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-swiper',
                    exportAs: 'weuiSwiper',
                    template: " <ng-content></ng-content> ",
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SwiperComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.NgZone },
        { type: SwiperConfig }
    ]; };
    SwiperComponent.propDecorators = {
        options: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        SwiperComponent.prototype.containerEl;
        /**
         * 等同于swiper[参数项](http://idangero.us/swiper/api/)
         * @type {?}
         */
        SwiperComponent.prototype.options;
        /**
         * Swiper 实例对象，可以通过 `\@ViewChild` 访问到它
         * @type {?}
         */
        SwiperComponent.prototype.swiper;
        /**
         * @type {?}
         * @private
         */
        SwiperComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        SwiperComponent.prototype.zone;
        /**
         * @type {?}
         * @private
         */
        SwiperComponent.prototype.DEF;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: swiper.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SwiperModule = /** @class */ (function () {
        function SwiperModule() {
        }
        return SwiperModule;
    }());
    SwiperModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [SwiperComponent],
                    exports: [SwiperComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-swiper.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.SwiperComponent = SwiperComponent;
    exports.SwiperConfig = SwiperConfig;
    exports.SwiperModule = SwiperModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-swiper.umd.js.map
