import { DOCUMENT, CommonModule } from '@angular/common';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ChangeDetectorRef, Output, ViewChild, Input, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { isAndroid, BaseService } from 'ngx-weui/core';
import { Observable, Subscription } from 'rxjs';
import { FormsModule } from '@angular/forms';
import { FormModule } from 'ngx-weui/form';
import { MaskModule } from 'ngx-weui/mask';
import { SliderModule } from 'ngx-weui/slider';

/**
 * @fileoverview added by tsickle
 * Generated from: dialog.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DialogConfig {
    constructor() {
        /**
         * 对话框类型，默认：`default`
         * default：默认文本或HTML格式
         * prompt：可输入对话框
         */
        this.type = 'default';
        /**
         * 样式，默认：`auto`
         */
        this.skin = 'auto';
        /**
         * 取消，返回false，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 取消按钮类型，默认：`default`
         */
        this.cancelType = 'default';
        /**
         * 确认，返回true，默认：`确认`
         */
        this.confirm = '确认';
        /**
         * 确认按钮类型，默认：`primary`
         */
        this.confirmType = 'primary';
        /**
         * 允许点击背景关闭，默认：`false`
         */
        this.backdrop = false;
    }
}
DialogConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ DialogConfig.ɵprov = ɵɵdefineInjectable({ factory: function DialogConfig_Factory() { return new DialogConfig(); }, token: DialogConfig, providedIn: "root" });
if (false) {
    /**
     * 对话框类型，默认：`default`
     * default：默认文本或HTML格式
     * prompt：可输入对话框
     * @type {?}
     */
    DialogConfig.prototype.type;
    /**
     * 样式，默认：`auto`
     * @type {?}
     */
    DialogConfig.prototype.skin;
    /**
     * 标题
     * @type {?}
     */
    DialogConfig.prototype.title;
    /**
     * 内容（支持HTML）
     * @type {?}
     */
    DialogConfig.prototype.content;
    /**
     * Input `type` 字段
     * @type {?}
     */
    DialogConfig.prototype.input;
    /**
     * Input `placeholder` 字段
     * @type {?}
     */
    DialogConfig.prototype.inputPlaceholder;
    /**
     * Input 初始化值
     * @type {?}
     */
    DialogConfig.prototype.inputValue;
    /**
     * Input `required` 字段，必填项校验失败时【确定】按钮为 `disabled` 状态，默认：`true`
     * @type {?}
     */
    DialogConfig.prototype.inputRequired;
    /**
     * Input 正则判断校验。
     * 如无指定，会根据 `input` 类型分别对：`email`、`url` 默认提供正则表达式
     * @type {?}
     */
    DialogConfig.prototype.inputRegex;
    /**
     * 输入参数无效时提醒文本
     * @type {?}
     */
    DialogConfig.prototype.inputError;
    /**
     * 数据数组，如果input值为 `select` `radio` `checkbox` 时为必填项
     * @type {?}
     */
    DialogConfig.prototype.inputOptions;
    /**
     * HTML元素属性对象，例如 `min` `max` 等，对象键表示属性名，对象值表示属性值
     * @type {?}
     */
    DialogConfig.prototype.inputAttributes;
    /**
     * 取消，返回false，默认：`取消`
     * @type {?}
     */
    DialogConfig.prototype.cancel;
    /**
     * 取消按钮类型，默认：`default`
     * @type {?}
     */
    DialogConfig.prototype.cancelType;
    /**
     * 确认，返回true，默认：`确认`
     * @type {?}
     */
    DialogConfig.prototype.confirm;
    /**
     * 确认按钮类型，默认：`primary`
     * @type {?}
     */
    DialogConfig.prototype.confirmType;
    /**
     * 自定义按钮组，当此属性存在时 `cancel` & `confirm` 参数将失效
     * @type {?}
     */
    DialogConfig.prototype.btns;
    /**
     * 允许点击背景关闭，默认：`false`
     * @type {?}
     */
    DialogConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: dialog.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 对话框，依赖于 `weui-textarea`、`weui-slider`
 *
 * 关于 `input==='prompt'` 若干细节：
 *  + 对话框内放表单在weui的表现并不是很如意，因此，在对话框增加 `.weui-dialog__prompt` 样式类名，请自行针对性进行一些样式的覆盖，`ngx-dialog` 不提供任何样式的修正。
 *  + 对于录入型表单其校验机制全都是依赖于正则，默认情况下内置 `email`、`url` 两种表单类型的正则。
 */
class DialogComponent {
    /**
     * @param {?} DEF
     * @param {?} cdr
     */
    constructor(DEF, cdr) {
        this.DEF = DEF;
        this.cdr = cdr;
        this._shown = false;
        /**
         * 打开动画结束后回调（唯一参数：对话框实例对象）
         */
        this.open = new EventEmitter();
        /**
         * 关闭动画开始时回调（唯一参数：对话框实例对象）
         */
        this.close = new EventEmitter();
        this._prompError = false;
    }
    /**
     * 对话框配置项
     * @param {?} value
     * @return {?}
     */
    set config(value) {
        /** @type {?} */
        const config = Object.assign(Object.assign({ backdrop: false }, this.DEF), value);
        if (config.skin === 'auto') {
            config.skin = isAndroid() ? 'android' : 'ios';
        }
        // 重组btns
        if (!config.btns) {
            config.btns = [];
            if (config.cancel) {
                config.btns.push({
                    text: config.cancel,
                    type: (/** @type {?} */ (config.cancelType)),
                    value: false,
                });
            }
            if (config.confirm) {
                config.btns.push({
                    text: config.confirm,
                    type: (/** @type {?} */ (config.confirmType)),
                    value: true,
                });
            }
        }
        // prompt
        if (config.type === 'prompt') {
            // 一些默认校验正则表达式
            if (!config.inputRegex) {
                switch (config.input) {
                    case 'email':
                        config.inputRegex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        if (!config.inputError) {
                            config.inputError = '邮箱格式不正确';
                        }
                        break;
                    case 'url':
                        config.inputRegex = /^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/;
                        if (!config.inputError) {
                            config.inputError = '网址格式不正确';
                        }
                        break;
                }
            }
            config.inputOptions = (/** @type {?} */ ((config.inputOptions || []))).slice(0);
            config.inputAttributes = Object.assign({ maxlength: null, min: 0, max: 100, step: 1 }, config.inputAttributes);
            // 默认值
            /** @type {?} */
            let defaultValue = config.inputValue;
            if (config.input === 'checkbox' && !Array.isArray(config.inputValue)) {
                defaultValue = typeof defaultValue !== 'undefined' ? [defaultValue] : [];
            }
            config.inputValue = defaultValue || '';
            this._promptData = config.inputValue;
            if (this._promptData) {
                this._config = config;
                this.promptCheck();
            }
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.setFocus();
            }), 100);
        }
        this._config = config;
    }
    /**
     * @return {?}
     */
    get config() {
        return this._config;
    }
    /**
     * @private
     * @return {?}
     */
    promptCheck() {
        if (this.config.inputRequired === true) {
            if (this.config.input === 'checkbox' && this._promptData.length === 0) {
                this._prompError = true;
                return false;
            }
            if (!this._promptData) {
                this._prompError = true;
                return false;
            }
        }
        if (this.config.inputRegex && !this.config.inputRegex.test(this._promptData.toString())) {
            this._prompError = true;
            return false;
        }
        this._prompError = false;
        return true;
    }
    /**
     * @private
     * @return {?}
     */
    setFocus() {
        /** @type {?} */
        const containerEl = this.container.nativeElement;
        /** @type {?} */
        let firstFormEl = null;
        if (this.config.type === 'prompt') {
            firstFormEl = containerEl.querySelector('input, textarea, select');
        }
        else {
            firstFormEl = containerEl.querySelector('.weui-dialog__btn_primary');
        }
        if (firstFormEl) {
            firstFormEl.focus();
        }
    }
    /**
     * @return {?}
     */
    _chanage() {
        this.promptCheck();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _keyup(event) {
        // tslint:disable-next-line: deprecation
        if (event.keyCode === 13) {
            this._onSelect();
        }
    }
    /**
     * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
     *
     * @return {?} 当 `type==='prompt'` 时会多一 `result` 属性表示结果值
     */
    show() {
        this._shown = true;
        this._prompError = false;
        this.cdr.detectChanges();
        // 模拟动画结束后回调
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.open.emit(this);
        }), 300);
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        (observer) => {
            this.observer = observer;
        }));
    }
    /**
     * 隐藏
     *
     * @param {?=} is_backdrop 是否从背景上点击
     * @return {?}
     */
    hide(is_backdrop = false) {
        if (is_backdrop === true && this.config.backdrop === false) {
            return;
        }
        this._shown = false;
        this.cdr.detectChanges();
        this.close.emit(this);
    }
    /**
     * @param {?=} menu
     * @return {?}
     */
    _onSelect(menu) {
        // 未指定时查找 `value===true` 的按钮
        if (!menu && (/** @type {?} */ (this.config.btns)).length > 0) {
            menu = (/** @type {?} */ (this.config.btns)).find((/**
             * @param {?} w
             * @return {?}
             */
            w => w.value === true));
        }
        /** @type {?} */
        const ret = menu;
        if (menu.value === true && this._config.type === 'prompt') {
            if (!this.promptCheck()) {
                return false;
            }
            ret.result = this._promptData;
        }
        this.observer.next(ret);
        this.observer.complete();
        this.hide();
        return false;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.observer && this.observer instanceof Subscription) {
            ((/** @type {?} */ (this.observer))).unsubscribe();
        }
    }
}
DialogComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-dialog',
                exportAs: 'weuiDialog',
                template: "<div class=\"weui-mask\" [ngClass]=\"{ 'weui-mask__in': _shown }\" (click)=\"hide(true)\"></div>\n<div class=\"weui-dialog\" [ngClass]=\"{\n    'weui-dialog__in': _shown,\n    'weui-skin_android': config.skin === 'android',\n    'weui-dialog__prompt': config.type === 'prompt'\n  }\" #container>\n  <div class=\"weui-dialog__hd\" *ngIf=\"config.title\">\n    <strong class=\"weui-dialog__title\">{{ config.title }}</strong>\n  </div>\n  <div class=\"weui-dialog__bd\" *ngIf=\"config.content\" [innerHTML]=\"config.content\"></div>\n  <div class=\"weui-cells\" *ngIf=\"config.type === 'prompt' && _shown\">\n    <ng-container [ngSwitch]=\"config.input\">\n      <div *ngSwitchCase=\"'textarea'\" class=\"weui-cell\" [ngClass]=\"{ 'weui-cell_warn': _prompError }\">\n        <div class=\"weui-cell__bd\">\n          <textarea class=\"weui-textarea\" placeholder=\"{{ config.inputPlaceholder }}\" [(ngModel)]=\"_promptData\"\n            name=\"_promptData\" (ngModelChange)=\"_chanage()\" weui-textarea [weui-cn]=\"config.inputAttributes.cn\"\n            [maxlength]=\"config.inputAttributes.maxlength\"></textarea>\n        </div>\n      </div>\n      <div *ngSwitchCase=\"'select'\" class=\"weui-cell weui-cell_select\">\n        <div class=\"weui-cell__bd\">\n          <select class=\"weui-select\" [(ngModel)]=\"_promptData\" name=\"_promptData\" (ngModelChange)=\"_chanage()\">\n            <option *ngFor=\"let i of config.inputOptions\" [ngValue]=\"i\">{{ i.text }}</option>\n          </select>\n        </div>\n      </div>\n      <div *ngSwitchCase=\"'radio'\" class=\"weui-cells_radio\">\n        <label class=\"weui-cell weui-check__label\" *ngFor=\"let i of config.inputOptions\">\n          <div class=\"weui-cell__bd\">\n            <p>{{ i.text }}</p>\n          </div>\n          <div class=\"weui-cell__ft\">\n            <input type=\"radio\" (click)=\"_promptData = i\" [checked]=\"i == _promptData\" (change)=\"_chanage()\"\n              class=\"weui-check\" />\n            <span class=\"weui-icon-checked\"></span>\n          </div>\n        </label>\n      </div>\n      <div *ngSwitchCase=\"'checkbox'\" class=\"weui-cells_checkbox\">\n        <label class=\"weui-cell weui-check__label\" *ngFor=\"let i of config.inputOptions\">\n          <div class=\"weui-cell__hd\">\n            <input type=\"checkbox\" class=\"weui-check\" (change)=\"_chanage()\" [weui-checklist]=\"_promptData\"\n              [weui-value]=\"i\" name=\"_promptData\" />\n            <i class=\"weui-icon-checked\"></i>\n          </div>\n          <div class=\"weui-cell__bd\">\n            <p>{{ i.text }}</p>\n          </div>\n        </label>\n      </div>\n      <div *ngSwitchCase=\"'range'\" class=\"weui-slider-box\" [(ngModel)]=\"_promptData\" name=\"_promptData\" weui-slider\n        [weui-min]=\"config.inputAttributes.min\" [weui-max]=\"config.inputAttributes.max\"\n        [weui-step]=\"config.inputAttributes.step\">\n        <div class=\"weui-slider\">\n          <div class=\"weui-slider__inner\">\n            <div class=\"weui-slider__track\"></div>\n            <div class=\"weui-slider__handler\"></div>\n          </div>\n        </div>\n        <div class=\"weui-slider-box__value\">{{ _promptData }}</div>\n      </div>\n      <div *ngSwitchDefault class=\"weui-cell\" [ngClass]=\"{ 'weui-cell_warn': _prompError }\">\n        <div class=\"weui-cell__bd\">\n          <input type=\"{{ config.input }}\" class=\"weui-input\" placeholder=\"{{ config.inputPlaceholder }}\"\n            [(ngModel)]=\"_promptData\" name=\"_promptData\" [maxlength]=\"config.inputAttributes.maxlength\"\n            (ngModelChange)=\"_chanage()\" (keyup)=\"_keyup($event)\" />\n        </div>\n        <div class=\"weui-cell__ft\">\n          <i class=\"weui-icon-warn\" *ngIf=\"_prompError\"></i>\n        </div>\n      </div>\n    </ng-container>\n  </div>\n  <div class=\"weui-dialog__error\" *ngIf=\"_prompError\">{{ config.inputError }}</div>\n  <div class=\"weui-dialog__ft\">\n    <a href=\"#\" *ngFor=\"let item of config.btns\" class=\"weui-dialog__btn weui-dialog__btn_{{ item.type }}\"\n      (click)=\"_onSelect(item)\">{{ item.text }}</a>\n  </div>\n</div>\n",
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
DialogComponent.ctorParameters = () => [
    { type: DialogConfig },
    { type: ChangeDetectorRef }
];
DialogComponent.propDecorators = {
    open: [{ type: Output }],
    close: [{ type: Output }],
    container: [{ type: ViewChild, args: ['container', { static: true },] }],
    config: [{ type: Input }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    DialogComponent.prototype._config;
    /**
     * @type {?}
     * @private
     */
    DialogComponent.prototype.observer;
    /** @type {?} */
    DialogComponent.prototype._shown;
    /**
     * 打开动画结束后回调（唯一参数：对话框实例对象）
     * @type {?}
     */
    DialogComponent.prototype.open;
    /**
     * 关闭动画开始时回调（唯一参数：对话框实例对象）
     * @type {?}
     */
    DialogComponent.prototype.close;
    /** @type {?} */
    DialogComponent.prototype.container;
    /** @type {?} */
    DialogComponent.prototype._prompError;
    /** @type {?} */
    DialogComponent.prototype._promptData;
    /**
     * @type {?}
     * @private
     */
    DialogComponent.prototype.DEF;
    /**
     * @type {?}
     * @private
     */
    DialogComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: dialog.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DialogService extends BaseService {
    /**
     * @param {?} resolver
     * @param {?} applicationRef
     * @param {?} injector
     * @param {?} doc
     */
    constructor(resolver, applicationRef, injector, doc) {
        super();
        this.resolver = resolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.doc = doc;
    }
    /**
     * 创建一个对话框并显示
     *
     * @param {?} data 对话框配置项
     * @return {?} 可订阅来获取结果
     */
    show(data) {
        /** @type {?} */
        const componentRef = this.build(DialogComponent);
        componentRef.instance.config = data;
        componentRef.instance.close.subscribe((/**
         * @return {?}
         */
        () => {
            setTimeout((/**
             * @return {?}
             */
            () => this.destroy(componentRef)), 300);
        }));
        return componentRef.instance.show();
    }
}
DialogService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
DialogService.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: Injector },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ DialogService.ɵprov = ɵɵdefineInjectable({ factory: function DialogService_Factory() { return new DialogService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: DialogService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @protected
     */
    DialogService.prototype.resolver;
    /**
     * @type {?}
     * @protected
     */
    DialogService.prototype.applicationRef;
    /**
     * @type {?}
     * @protected
     */
    DialogService.prototype.injector;
    /**
     * @type {?}
     * @protected
     */
    DialogService.prototype.doc;
}

/**
 * @fileoverview added by tsickle
 * Generated from: dialog.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DialogModule {
}
DialogModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, FormsModule, MaskModule, FormModule, SliderModule],
                declarations: [DialogComponent],
                exports: [DialogComponent],
                entryComponents: [DialogComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-dialog.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DialogComponent, DialogConfig, DialogModule, DialogService };
//# sourceMappingURL=ngx-weui-dialog.js.map
