import { Injectable, ɵɵdefineInjectable, Component, ChangeDetectionStrategy, ViewEncapsulation, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: loadmore.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoadmoreConfig {
    constructor() {
        /**
         * 类型，默认：`loading`
         */
        this.type = 'loading';
        /**
         * 当type=='loading'时显示的文本，默认：`正在加载`
         */
        this.loadingText = '正在加载';
        /**
         * 当type=='line'时显示的文本，默认：`暂无数据`
         */
        this.lineText = '暂无数据';
    }
}
LoadmoreConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ LoadmoreConfig.ɵprov = ɵɵdefineInjectable({ factory: function LoadmoreConfig_Factory() { return new LoadmoreConfig(); }, token: LoadmoreConfig, providedIn: "root" });
if (false) {
    /**
     * 类型，默认：`loading`
     * @type {?}
     */
    LoadmoreConfig.prototype.type;
    /**
     * 当type=='loading'时显示的文本，默认：`正在加载`
     * @type {?}
     */
    LoadmoreConfig.prototype.loadingText;
    /**
     * 当type=='line'时显示的文本，默认：`暂无数据`
     * @type {?}
     */
    LoadmoreConfig.prototype.lineText;
}

/**
 * @fileoverview added by tsickle
 * Generated from: loadmore.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoadmoreComponent {
    /**
     * @param {?} DEF
     */
    constructor(DEF) {
        /**
         * 类型，默认：`loading`
         */
        this.type = 'loading';
        /**
         * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
         */
        this.loadingText = '正在加载';
        /**
         * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
         */
        this.lineText = '暂无数据';
        Object.assign(this, DEF);
    }
}
LoadmoreComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-loadmore',
                exportAs: 'weuiLoadmore',
                template: "<div\n  class=\"weui-loadmore\"\n  [ngClass]=\"{\n    'weui-loadmore_line': type !== 'loading',\n    'weui-loadmore_dot': type === 'dot'\n  }\"\n>\n  <i class=\"weui-loading\" *ngIf=\"type === 'loading'\"></i>\n  <span class=\"weui-loadmore__tips\">{{ type === 'dot' ? '' : type === 'line' ? lineText : loadingText }}</span>\n</div>\n",
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
LoadmoreComponent.ctorParameters = () => [
    { type: LoadmoreConfig }
];
LoadmoreComponent.propDecorators = {
    type: [{ type: Input }],
    loadingText: [{ type: Input }],
    lineText: [{ type: Input }]
};
if (false) {
    /**
     * 类型，默认：`loading`
     * @type {?}
     */
    LoadmoreComponent.prototype.type;
    /**
     * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
     * @type {?}
     */
    LoadmoreComponent.prototype.loadingText;
    /**
     * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
     * @type {?}
     */
    LoadmoreComponent.prototype.lineText;
}

/**
 * @fileoverview added by tsickle
 * Generated from: loadmore.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoadmoreModule {
}
LoadmoreModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [LoadmoreComponent],
                exports: [LoadmoreComponent],
                entryComponents: [LoadmoreComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-loadmore.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LoadmoreComponent, LoadmoreConfig, LoadmoreModule };
//# sourceMappingURL=ngx-weui-loadmore.js.map
