import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, Inject, Input, Output, Injector, ChangeDetectorRef, forwardRef, ViewChild, ComponentFactoryResolver, ApplicationRef, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { __decorate, __metadata } from 'tslib';
import { DOCUMENT, DatePipe, CommonModule } from '@angular/common';
import { InputNumber, InputBoolean, BaseService } from 'ngx-weui/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * Generated from: picker.types.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function PickerOptions() { }
if (false) {
    /**
     * 类型
     * default：无任何显示
     * form：会以表单的形式出现
     * @see https://cipchk.github.io/ngx-weui/#/example/picker
     * @type {?|undefined}
     */
    PickerOptions.prototype.type;
    /**
     * 提示分隔符信息，当type==='form'时有效
     * @type {?|undefined}
     */
    PickerOptions.prototype.separator;
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?|undefined}
     */
    PickerOptions.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?|undefined}
     */
    PickerOptions.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?|undefined}
     */
    PickerOptions.prototype.backdrop;
    /**
     * 类名
     * @type {?|undefined}
     */
    PickerOptions.prototype.className;
}
/**
 * @record
 */
function PickerChangeData() { }
if (false) {
    /** @type {?} */
    PickerChangeData.prototype.value;
    /** @type {?} */
    PickerChangeData.prototype.items;
}
/**
 * @record
 */
function PickerDateChangeData() { }
if (false) {
    /** @type {?} */
    PickerDateChangeData.prototype.value;
    /** @type {?} */
    PickerDateChangeData.prototype.formatValue;
    /** @type {?} */
    PickerDateChangeData.prototype.items;
}
/**
 * @record
 */
function PickerData() { }
if (false) {
    /**
     * 显示文本
     * @type {?}
     */
    PickerData.prototype.label;
    /**
     * 值
     * @type {?}
     */
    PickerData.prototype.value;
    /**
     * 是否禁用
     * @type {?|undefined}
     */
    PickerData.prototype.disabled;
    /* Skipping unhandled member: [key: string]: NwSafeAny;*/
}
/**
 * @record
 */
function PickerBaseConfig() { }
if (false) {
    /**
     * 标题
     * @type {?|undefined}
     */
    PickerBaseConfig.prototype.title;
    /**
     * 配置项
     * @type {?|undefined}
     */
    PickerBaseConfig.prototype.options;
    /** @type {?|undefined} */
    PickerBaseConfig.prototype.placeholder;
    /** @type {?|undefined} */
    PickerBaseConfig.prototype.disabled;
    /** @type {?|undefined} */
    PickerBaseConfig.prototype.value;
}
/**
 * @record
 */
function PickerCreateConfig() { }
if (false) {
    /**
     * 数据源
     * @type {?}
     */
    PickerCreateConfig.prototype.data;
    /**
     * 默认值（限单列时会根据值自动解析，而对多列使用defaultSelect自行解析）
     * @type {?|undefined}
     */
    PickerCreateConfig.prototype.value;
    /**
     * 当前默认位置，数组的长度必须等同于 groups 长度
     * @type {?|undefined}
     */
    PickerCreateConfig.prototype.defaultSelect;
}
/**
 * @record
 */
function PickerCityDataMap() { }
if (false) {
    /**
     * 标签映射键值，默认：`name`
     * @type {?}
     */
    PickerCityDataMap.prototype.label;
    /**
     * 值映射键值，默认：`code`
     * @type {?}
     */
    PickerCityDataMap.prototype.value;
    /**
     * 子项列表映射键值，默认：`sub`
     * @type {?}
     */
    PickerCityDataMap.prototype.items;
}
/**
 * @record
 */
function PickerCityData() { }
if (false) {
    /** @type {?} */
    PickerCityData.prototype.name;
    /** @type {?} */
    PickerCityData.prototype.code;
    /** @type {?|undefined} */
    PickerCityData.prototype.sub;
    /* Skipping unhandled member: [key: string]: NwSafeAny;*/
}
/**
 * @record
 */
function PickerCityConfig() { }
if (false) {
    /**
     * 城市数据，可以参考示例中的数据格式
     * @type {?}
     */
    PickerCityConfig.prototype.data;
    /**
     * 默认值，即城市编号
     * @type {?|undefined}
     */
    PickerCityConfig.prototype.value;
    /**
     * 映射键值配置
     * @type {?|undefined}
     */
    PickerCityConfig.prototype.dataMap;
}
/**
 * @record
 */
function PickerDateTimeConfig() { }
if (false) {
    /**
     * 类型
     * + `date-ym` 年月
     * + `date` 日期
     * + `datetime` 日期&时间（不包括秒）
     * + `time` 时间（不包括秒）
     * @type {?|undefined}
     */
    PickerDateTimeConfig.prototype.type;
    /**
     * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
     * @type {?|undefined}
     */
    PickerDateTimeConfig.prototype.format;
    /**
     * 默认显示日期
     * @type {?|undefined}
     */
    PickerDateTimeConfig.prototype.value;
    /**
     * 最小时间范围，当前只限定年月日，暂不包括时间范围
     * @type {?|undefined}
     */
    PickerDateTimeConfig.prototype.min;
    /**
     * 最大时间范围，当前只限定年月日，暂不包括时间范围
     * @type {?|undefined}
     */
    PickerDateTimeConfig.prototype.max;
}
/**
 * @record
 */
function PickerGroupChange() { }
if (false) {
    /** @type {?} */
    PickerGroupChange.prototype.item;
    /** @type {?} */
    PickerGroupChange.prototype.index;
    /** @type {?} */
    PickerGroupChange.prototype.groupIndex;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PickerConfig {
    constructor() {
        /**
         * 取消按钮文本，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 确定按钮文本，默认：`确定`
         */
        this.confirm = '确定';
        /**
         * 允许点击背景关闭，默认：`true`
         */
        this.backdrop = true;
    }
}
PickerConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ PickerConfig.ɵprov = ɵɵdefineInjectable({ factory: function PickerConfig_Factory() { return new PickerConfig(); }, token: PickerConfig, providedIn: "root" });
if (false) {
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?}
     */
    PickerConfig.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?}
     */
    PickerConfig.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?}
     */
    PickerConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-group.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PickerGroupComponent {
    /**
     * @param {?} doc
     */
    constructor(doc) {
        this.doc = doc;
        /**
         * 当前默认位置
         */
        this.defaultIndex = -1;
        /**
         * 变更回调
         */
        this.change = new EventEmitter();
        this.defaults = {
            offset: 2,
            // 列表初始化时的偏移量（列表初始化时，选项是聚焦在中间的，通过offset强制往上挪3项，以达到初始选项是为顶部的那项）
            rowHeight: 48,
            // 列表每一行的高度
            bodyHeight: 5 * 48,
            // picker的高度，用于辅助点击滚动的计算
            inertiaTime: 150,
            // 惯性滑动的保持时间，此值直接影响“灵敏度” (单位：ms)
            slideDuration: 300,
        };
        // 手滑动的速度 (用途：速度乘以惯性滑动的时间, 例如 300ms, 计算出应该滑动的距离)
        this._animating = false;
        this._distance = 0;
    }
    /**
     * @private
     * @return {?}
     */
    _getWin() {
        return this.doc.defaultView || window;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.defaultIndex) {
            if (this.defaultIndex < 0 || (this.items && this.defaultIndex >= this.items.length)) {
                this.defaultIndex = 0;
            }
            this._distance = (this.defaults.offset - this.defaultIndex) * this.defaults.rowHeight;
        }
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onTouchStart(e) {
        if (this.items.length <= 1) {
            return;
        }
        this.startY = e.changedTouches[0].pageY;
        this.startTime = +new Date();
    }
    /**
     * @param {?} e
     * @return {?}
     */
    onTouchMove(e) {
        if (this.items.length <= 1) {
            return;
        }
        /** @type {?} */
        const endTime = +new Date();
        this.endY = e.changedTouches[0].pageY;
        // 计算滑动的速度: 距离 / 时间
        /** @type {?} */
        const _distance = this.endY - this.startY;
        this.speed = _distance / (endTime - this.startTime);
        // 重新设置开始时间、开始位置
        this.startTime = endTime;
        this.startY = this.endY;
        this._animating = false; // ms
        this._distance += _distance; // 内容移动的距离
        e.preventDefault();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    onTouchEnd(event) {
        if (!this.startY) {
            return;
        }
        this.endY = event.changedTouches[0].pageY;
        /**
         * 思路:
         * 根据最后一次touchmove事件的速度(speed)，判断是否执行惯性滑动；
         * 如果speed大于1、小于5，则根据速度乘以惯性滑动的时间(如150ms)，计算出应该滑动的距离；
         * 如果speed大于5，则按照屏幕的高度(减去列表高度的一半)，作为该滑动的距离。
         * @type {?}
         */
        const _speed = Math.abs(this.speed);
        if (_speed >= 5) {
            /** @type {?} */
            const windowY = this._getWin().innerHeight - this.defaults.bodyHeight / 2;
            this.stop(windowY - this.endY);
        }
        else if (_speed >= 1) {
            /** @type {?} */
            const diff = this.speed * this.defaults.inertiaTime;
            this.stop(diff);
        }
        else {
            this.stop(0);
        }
        this.startY = 0;
    }
    /**
     * @private
     * @param {?} diff
     * @return {?}
     */
    stop(diff) {
        /** @type {?} */
        let dist = this._distance + diff;
        /** @type {?} */
        const defaults = this.defaults;
        // 移动到最接近的那一行
        dist = Math.round(dist / defaults.rowHeight) * defaults.rowHeight;
        /** @type {?} */
        const max = this._getMax(defaults.offset, defaults.rowHeight);
        /** @type {?} */
        const min = this._getMin(defaults.offset, defaults.rowHeight, this.items.length);
        // 不要超过最大值或者最小值
        dist = Math.max(Math.min(dist, max), min);
        // 如果是 disabled 的就跳过
        /** @type {?} */
        let index = defaults.offset - dist / defaults.rowHeight;
        while (!!this.items[index] && this.items[index].disabled) {
            diff > 0 ? ++index : --index;
        }
        dist = (defaults.offset - index) * defaults.rowHeight;
        this._animating = true;
        this._distance = dist; // px
        // 触发选择事件
        this.onChange(this.items[index], index);
    }
    /**
     * @private
     * @param {?} item
     * @param {?=} index
     * @return {?}
     */
    onChange(item, index = 0) {
        this.change.emit({ item, index, groupIndex: this.groupIndex });
    }
    /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @return {?}
     */
    _getMax(offset, rowHeight) {
        return offset * rowHeight;
    }
    /**
     * @private
     * @param {?} offset
     * @param {?} rowHeight
     * @param {?} length
     * @return {?}
     */
    _getMin(offset, rowHeight, length) {
        return -(rowHeight * (length - offset - 1));
    }
}
PickerGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-picker-group',
                exportAs: 'weuiPickerGroup',
                template: "<ng-content></ng-content>\n<div class=\"weui-picker__mask\"></div>\n<div class=\"weui-picker__indicator\"></div>\n<div\n  class=\"weui-picker__content\"\n  [ngStyle]=\"{\n    transform: 'translate3d(0,' + _distance + 'px, 0px)',\n    transition: _animating ? 'all 0.3s ease 0s' : 'none'\n  }\"\n>\n  <div class=\"weui-picker__item\" *ngFor=\"let item of items\" [ngClass]=\"{ 'weui-picker__item_disabled': item.disabled }\">\n    {{ item.label || item.value }}\n  </div>\n</div>\n",
                host: {
                    '[class.weui-picker__group]': 'true',
                    '(touchstart)': 'onTouchStart($event)',
                    '(touchmove)': 'onTouchMove($event)',
                    '(touchend)': 'onTouchEnd($event)',
                },
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
PickerGroupComponent.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
PickerGroupComponent.propDecorators = {
    items: [{ type: Input }],
    defaultIndex: [{ type: Input }],
    groupIndex: [{ type: Input }],
    change: [{ type: Output }]
};
__decorate([
    InputNumber(),
    __metadata("design:type", Number)
], PickerGroupComponent.prototype, "defaultIndex", void 0);
__decorate([
    InputNumber(),
    __metadata("design:type", Number)
], PickerGroupComponent.prototype, "groupIndex", void 0);
if (false) {
    /**
     * 数据列表
     * @type {?}
     */
    PickerGroupComponent.prototype.items;
    /**
     * 当前默认位置
     * @type {?}
     */
    PickerGroupComponent.prototype.defaultIndex;
    /**
     * 多列中的位置
     * @type {?}
     */
    PickerGroupComponent.prototype.groupIndex;
    /**
     * 变更回调
     * @type {?}
     */
    PickerGroupComponent.prototype.change;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.defaults;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.startTime;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.startY;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.endY;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.speed;
    /** @type {?} */
    PickerGroupComponent.prototype._animating;
    /** @type {?} */
    PickerGroupComponent.prototype._distance;
    /**
     * @type {?}
     * @private
     */
    PickerGroupComponent.prototype.doc;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-base.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PickerBaseComponent {
    /**
     * @param {?} DEF
     * @param {?} injector
     * @param {?} cdr
     */
    constructor(DEF, injector, cdr) {
        this.DEF = DEF;
        this.injector = injector;
        this.cdr = cdr;
        /**
         * 列变更时回调
         */
        this.groupChange = new EventEmitter();
        /**
         * 取消后回调
         */
        this.cancel = new EventEmitter();
        /**
         * 显示时回调
         */
        this.show = new EventEmitter();
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    /**
     * @param {?} _value
     * @return {?}
     */
    writeValue(_value) { }
}
PickerBaseComponent.decorators = [
    { type: Component, args: [{ template: `` }] }
];
/** @nocollapse */
PickerBaseComponent.ctorParameters = () => [
    { type: PickerConfig },
    { type: Injector },
    { type: ChangeDetectorRef }
];
PickerBaseComponent.propDecorators = {
    options: [{ type: Input }],
    placeholder: [{ type: Input }],
    title: [{ type: Input }],
    disabled: [{ type: Input }],
    groupChange: [{ type: Output }],
    cancel: [{ type: Output }],
    show: [{ type: Output }],
    hide: [{ type: Output }]
};
__decorate([
    InputBoolean(),
    __metadata("design:type", Boolean)
], PickerBaseComponent.prototype, "disabled", void 0);
if (false) {
    /**
     * 配置项
     * @type {?}
     */
    PickerBaseComponent.prototype.options;
    /**
     * 当options.type=='form'时，占位符文本
     * @type {?}
     */
    PickerBaseComponent.prototype.placeholder;
    /** @type {?} */
    PickerBaseComponent.prototype.title;
    /** @type {?} */
    PickerBaseComponent.prototype.disabled;
    /**
     * 列变更时回调
     * @type {?}
     */
    PickerBaseComponent.prototype.groupChange;
    /**
     * 取消后回调
     * @type {?}
     */
    PickerBaseComponent.prototype.cancel;
    /**
     * 显示时回调
     * @type {?}
     */
    PickerBaseComponent.prototype.show;
    /**
     * 隐藏后回调
     * @type {?}
     */
    PickerBaseComponent.prototype.hide;
    /**
     * @type {?}
     * @protected
     */
    PickerBaseComponent.prototype.DEF;
    /**
     * @type {?}
     * @protected
     */
    PickerBaseComponent.prototype.injector;
    /**
     * @type {?}
     * @protected
     */
    PickerBaseComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PickerComponent extends PickerBaseComponent {
    constructor() {
        super(...arguments);
        this._showP = false;
        this._shown = false;
        this._text = '';
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         */
        this.change = new EventEmitter();
        this.onChange = (/**
         * @param {?} _
         * @return {?}
         */
        (_) => { });
        this.onTouched = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * 当前默认位置，数组的长度必须等同于 groups 长度
     * @param {?} d
     * @return {?}
     */
    set defaultSelect(d) {
        if (d) {
            this._selected = d;
        }
    }
    /**
     * 多列数据，以数组的长度来决定几列数据
     * 支持string[]单列数组，单纯只是为了方便
     * @param {?} d
     * @return {?}
     */
    set groups(d) {
        if (!d) {
            throw new Error('无效数据源');
        }
        if (d.length > 0) {
            if (typeof d[0] === 'string') {
                d = [
                    ((/** @type {?} */ (d))).map((/**
                     * @param {?} v
                     * @return {?}
                     */
                    (v) => {
                        return { label: v, value: v };
                    })),
                ];
            }
        }
        this._groups = (/** @type {?} */ (d));
        this._selected = this._selected ? this._selected : Array(d.length).fill(0);
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.parseOptions();
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?} fh
     * @return {THIS}
     */
    _onHide(fh) {
        if (!fh && !(/** @type {?} */ (this)).options.backdrop) {
            return (/** @type {?} */ (this));
        }
        (/** @type {?} */ (this))._shown = false;
        setTimeout((/**
         * @return {?}
         */
        () => {
            (/** @type {?} */ (this))._showP = false;
            (/** @type {?} */ (this)).hide.emit();
        }), 300);
        return (/** @type {?} */ (this));
    }
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    _onShow() {
        if ((/** @type {?} */ (this)).disabled) {
            return (/** @type {?} */ (this));
        }
        (/** @type {?} */ (this))._showP = true;
        (/** @type {?} */ (this))._shown = true;
        (/** @type {?} */ (this)).show.emit();
        return (/** @type {?} */ (this));
    }
    /**
     * @private
     * @return {?}
     */
    parseOptions() {
        this.options = (/** @type {?} */ (Object.assign(Object.assign({ type: 'form', cancel: '取消', confirm: '确定', backdrop: true, gruopCount: null, separator: ' ' }, this.DEF), this.options)));
    }
    /**
     * @private
     * @return {?}
     */
    getSelecteItem() {
        /** @type {?} */
        const res = [];
        this._groups.forEach((/**
         * @param {?} items
         * @param {?} idx
         * @return {?}
         */
        (items, idx) => {
            /** @type {?} */
            const item = items[this._selected[idx]];
            if (item) {
                res.push(item);
            }
        }));
        return res;
    }
    /**
     * @template THIS
     * @this {THIS}
     * @param {?=} res
     * @return {THIS}
     */
    _setText(res = null) {
        if (res == null) {
            res = (/** @type {?} */ (this)).getSelecteItem();
        }
        if (res.length > 0) {
            (/** @type {?} */ (this))._text = res.map((/**
             * @param {?} i
             * @return {?}
             */
            (i) => i.label || i.value)).join((/** @type {?} */ (this)).options.separator);
        }
        return (/** @type {?} */ (this));
    }
    // 根据_value解析成相应值位置
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    _setDefault() {
        (/** @type {?} */ (this))._selected = [];
        (/** @type {?} */ (this))._groups.forEach((/**
         * @param {?} items
         * @return {?}
         */
        (items) => {
            /** @type {?} */
            let idx = items.findIndex((/**
             * @param {?} i
             * @return {?}
             */
            (i) => i.value === (/** @type {?} */ (this))._value));
            if (idx <= -1) {
                idx = 0;
            }
            (/** @type {?} */ (this))._selected.push(idx);
        }));
        return (/** @type {?} */ (this));
    }
    /**
     * @param {?} data
     * @param {?} groupIndex
     * @return {?}
     */
    _onGroupChange(data, groupIndex) {
        this._selected[groupIndex] = data.index;
        this.groupChange.emit({ item: data.item, index: data.index, groupIndex });
    }
    /**
     * @return {?}
     */
    _onCancel() {
        this.cancel.emit();
        this._onHide(true);
        return false;
    }
    /**
     * @return {?}
     */
    _onConfirm() {
        /** @type {?} */
        const res = this.getSelecteItem();
        this._setText(res);
        /** @type {?} */
        const lastItem = res[res.length - 1] || {};
        /** @type {?} */
        const val = lastItem.value || lastItem.label;
        this.onChange(val);
        this.onTouched();
        this.change.emit({ value: val, items: res });
        this._onHide(true);
        return false;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.options) {
            this.parseOptions();
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (!value) {
            this._text = '';
        }
        if (value && value !== this._value) {
            this._value = value;
            // todo：当ngModel传递一个未列表中的值的情况 & 多列时数据对应问题
            this._setDefault()._setText();
        }
        this.cdr.detectChanges();
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    /**
     * @param {?} ev
     * @return {?}
     */
    _onFocus(ev) {
        ((/** @type {?} */ ((/** @type {?} */ (ev.target))))).blur();
    }
}
PickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-picker',
                exportAs: 'weuiPicker',
                template: "<input\n  type=\"text\"\n  class=\"weui-input\"\n  value=\"{{ _text }}\"\n  placeholder=\"{{ placeholder }}\"\n  readonly=\"readonly\"\n  (focus)=\"_onFocus($event)\"\n  (click)=\"_onShow()\"\n  [disabled]=\"disabled\"\n  *ngIf=\"options.type === 'form'\"\n/>\n<div [ngClass]=\"options.className\" [hidden]=\"!_showP\">\n  <div class=\"weui-mask\" (click)=\"_onHide(false)\" [ngClass]=\"{ 'weui-animate-fade-in': _shown, 'weui-animate-fade-out': !_shown }\"></div>\n  <div class=\"weui-half-screen-dialog weui-picker\" [ngClass]=\"{ 'weui-animate-slide-up': _shown, 'weui-animate-slide-down': !_shown }\">\n    <div class=\"weui-half-screen-dialog__hd\">\n      <div class=\"weui-half-screen-dialog__hd__side\">\n        <button (click)=\"_onCancel()\" class=\"weui-icon-btn weui-icon-btn_close weui-picker__btn\">{{ options.cancel }}</button>\n      </div>\n      <div *ngIf=\"title\" class=\"weui-half-screen-dialog__hd__main\">\n        <strong class=\"weui-half-screen-dialog__title\">{{ title }}</strong>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__bd\">\n      <div class=\"weui-picker__bd\">\n        <weui-picker-group\n          tappable\n          *ngFor=\"let items of _groups; let i = index\"\n          [attr.data-index]=\"i\"\n          [items]=\"items\"\n          [defaultIndex]=\"_selected[i]\"\n          [groupIndex]=\"i\"\n          (change)=\"_onGroupChange($event, i)\"\n        ></weui-picker-group>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__ft\">\n      <a class=\"weui-btn weui-btn_primary weui-picker__btn\" (click)=\"_onConfirm()\">{{ options.confirm }}</a>\n    </div>\n  </div>\n</div>\n",
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => PickerComponent)),
                        multi: true,
                    },
                ],
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
PickerComponent.propDecorators = {
    change: [{ type: Output }],
    defaultSelect: [{ type: Input }],
    groups: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    PickerComponent.prototype._showP;
    /** @type {?} */
    PickerComponent.prototype._shown;
    /** @type {?} */
    PickerComponent.prototype._value;
    /** @type {?} */
    PickerComponent.prototype._selected;
    /** @type {?} */
    PickerComponent.prototype._groups;
    /** @type {?} */
    PickerComponent.prototype._text;
    /**
     * 确认后回调当前选择数据（包括已选面板所有数据）
     * @type {?}
     */
    PickerComponent.prototype.change;
    /**
     * @type {?}
     * @private
     */
    PickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    PickerComponent.prototype.onTouched;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-city.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const DATA_MAP = {
    label: 'name',
    value: 'code',
    items: 'sub',
};
/**
 * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
 */
class CityPickerComponent extends PickerBaseComponent {
    constructor() {
        super(...arguments);
        this.change = new EventEmitter();
        this._tmpData = null;
        this._dataMap = DATA_MAP;
        this._groups = [];
        this._selected = [];
        this.onChange = (/**
         * @param {?} _
         * @return {?}
         */
        (_) => { });
        this.onTouched = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set dataMap(val) {
        this._dataMap = Object.assign(Object.assign({}, DATA_MAP), val);
    }
    /**
     * @param {?} d
     * @return {?}
     */
    set data(d) {
        this._tmpData = d;
        this.parseData(this._tmpData, this._dataMap.items, this._selected);
    }
    /**
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} selected
     * @param {?=} group
     * @param {?=} newSelected
     * @return {?}
     */
    parseData(data, subKey, selected = [], group = [], newSelected = []) {
        /** @type {?} */
        let _selected = 0;
        if (Array.isArray(selected) && selected.length > 0) {
            /** @type {?} */
            const _selectedClone = selected.slice(0);
            _selected = (/** @type {?} */ (_selectedClone.shift()));
            selected = _selectedClone;
        }
        if (typeof data[_selected] === 'undefined') {
            _selected = 0;
        }
        newSelected.push(_selected);
        /** @type {?} */
        const item = data[_selected];
        /** @type {?} */
        const _group = (/** @type {?} */ (JSON.parse(JSON.stringify(data))));
        /** @type {?} */
        const map = this._dataMap;
        _group.forEach((/**
         * @param {?} g
         * @return {?}
         */
        (g) => {
            delete g[subKey];
            g.label = g[map.label];
            g.value = g[map.value];
        }));
        group.push(_group);
        if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
            return this.parseData(item[subKey], subKey, selected, group, newSelected);
        }
        else {
            this._groups = group;
            this._selected = newSelected;
            return { groups: group, newSelected };
        }
    }
    /**
     * 将值转换成位置
     * @private
     * @param {?} data
     * @param {?} subKey
     * @param {?=} dept
     * @param {?=} newSelected
     * @return {?}
     */
    valueToSelect(data, subKey, dept = 1, newSelected = []) {
        /** @type {?} */
        const code = (this._value.substr(0, dept * 2) + '0000').substr(0, 6);
        /** @type {?} */
        let _selected = data.findIndex((/**
         * @param {?} w
         * @return {?}
         */
        (w) => w[this._dataMap.value] === code));
        if (_selected <= -1) {
            _selected = 0;
        }
        newSelected.push(_selected);
        /** @type {?} */
        const item = data[_selected];
        if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
            return this.valueToSelect(item[subKey], subKey, ++dept, newSelected);
        }
        else {
            this._selected = newSelected;
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.pickerComp._setText();
            }), 100);
            return newSelected;
        }
    }
    /**
     * @param {?} data
     * @return {?}
     */
    _onChange(data) {
        this.onChange(data.value);
        this.onTouched();
        this.change.emit(data);
    }
    /**
     * @param {?} res
     * @return {?}
     */
    _onGroupChange(res) {
        this._selected[res.groupIndex] = res.index;
        if (res.groupIndex !== 2) {
            this.parseData((/** @type {?} */ (this._tmpData)), this._dataMap.items, this._selected);
        }
        this.groupChange.emit(res);
    }
    /**
     * @return {?}
     */
    _onCityCancelChange() {
        this.cancel.emit();
    }
    /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    _triggerShow() {
        this.pickerComp._onShow();
    }
    /**
     * @return {?}
     */
    _onShow() {
        this.show.emit();
    }
    /**
     * @return {?}
     */
    _onHide() {
        this.hide.emit();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (!value) {
            this.pickerComp._text = '';
            return;
        }
        this._value = value;
        if (this._value && this._value.length === 6) {
            /** @type {?} */
            const items = this._dataMap.items;
            this.valueToSelect((/** @type {?} */ (this._tmpData)), items, 1);
            this.parseData((/** @type {?} */ (this._tmpData)), items, this._selected);
        }
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._tmpData = null;
        this._groups = null;
    }
}
CityPickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-city-picker',
                exportAs: 'weuiCityPicker',
                template: `
    <weui-picker
      [placeholder]="placeholder"
      [groups]="_groups!"
      [defaultSelect]="_selected"
      [disabled]="disabled"
      [title]="title"
      [options]="options"
      (show)="_onShow()"
      (hide)="_onHide()"
      (change)="_onChange($event)"
      (groupChange)="_onGroupChange($event)"
      (cancel)="_onCityCancelChange()"
    ></weui-picker>
  `,
                providers: [
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => CityPickerComponent)),
                        multi: true,
                    },
                ],
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
CityPickerComponent.propDecorators = {
    dataMap: [{ type: Input }],
    data: [{ type: Input }],
    pickerComp: [{ type: ViewChild, args: [PickerComponent, { static: true },] }],
    change: [{ type: Output }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype.pickerComp;
    /** @type {?} */
    CityPickerComponent.prototype.change;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype._tmpData;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype._dataMap;
    /** @type {?} */
    CityPickerComponent.prototype._value;
    /** @type {?} */
    CityPickerComponent.prototype._groups;
    /** @type {?} */
    CityPickerComponent.prototype._selected;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    CityPickerComponent.prototype.onTouched;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker-date.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const FORMAT = {
    format: null,
    yu: '年',
    Mu: '月',
    du: '日',
    hu: '时',
    mu: '分',
};
/**
 * 日期时间选择器
 */
class DatePickerComponent extends PickerBaseComponent {
    constructor() {
        super(...arguments);
        this.initFlag = false;
        this._format = Object.assign({}, FORMAT);
        this._groups = [];
        this._selected = [];
        /**
         * 类型
         * + `date-ym` 年月
         * + `date` 日期
         * + `datetime` 日期&时间（不包括秒）
         * + `time` 时间（不包括秒）
         */
        this.type = 'date';
        this.change = new EventEmitter();
        this.onChange = (/**
         * @param {?} _
         * @return {?}
         */
        (_) => { });
        this.onTouched = (/**
         * @return {?}
         */
        () => { });
    }
    /**
     * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
     * @param {?} v
     * @return {?}
     */
    set format(v) {
        if (typeof v === 'string') {
            this._format = Object.assign(Object.assign({}, FORMAT), { format: v });
        }
        else {
            this._format = Object.assign(Object.assign({}, FORMAT), v);
        }
    }
    /**
     * @private
     * @return {?}
     */
    get datePipe() {
        return this.injector.get(DatePipe);
    }
    // todo: 太粗暴，需要优化代码
    /**
     * @private
     * @return {?}
     */
    genGroups() {
        if (!this._value) {
            this._value = new Date();
        }
        this._groups = [];
        this._selected = [];
        if (~this.type.indexOf('date')) {
            this.genDateGroups();
        }
        if (~this.type.indexOf('time')) {
            this.genDateTimeGroups();
        }
    }
    /**
     * @private
     * @return {?}
     */
    genDateGroups() {
        /** @type {?} */
        const year = this._value.getFullYear();
        /** @type {?} */
        const month = this._value.getMonth() + 1;
        /** @type {?} */
        const day = this._value.getDate();
        // year
        /** @type {?} */
        let _selected = 0;
        /** @type {?} */
        let startYear = year - 10;
        /** @type {?} */
        let endYear = year + 10;
        if (this.min) {
            startYear = this.min.getFullYear();
        }
        if (this.max) {
            endYear = this.max.getFullYear();
        }
        this._groups.push(Array(endYear - startYear + 1)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        (_v, idx) => {
            /** @type {?} */
            const val = startYear + idx;
            if (val === year) {
                _selected = idx;
            }
            return { label: val + (/** @type {?} */ (this._format.yu)), value: val };
        })));
        this._selected.push(_selected);
        // month
        /** @type {?} */
        const cy = this._groups[0][_selected].value;
        /** @type {?} */
        let startMonth = 1;
        /** @type {?} */
        let endMonth = 12;
        if (cy === startYear) {
            startMonth = this.min.getMonth() + 1;
        }
        if (cy === endYear) {
            endMonth = this.max.getMonth() + 1;
        }
        _selected = 0;
        this._groups.push(Array(endMonth - startMonth + 1)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        (_v, idx) => {
            /** @type {?} */
            const val = startMonth + idx;
            if (val === month) {
                _selected = idx;
            }
            return { label: val + (/** @type {?} */ (this._format.Mu)), value: val };
        })));
        this._selected.push(_selected);
        // day
        if (this.type !== 'date-ym') {
            /** @type {?} */
            const cm = this._groups[1][_selected].value;
            /** @type {?} */
            let startDay = 1;
            /** @type {?} */
            let endDay = new Date(year, month, 0).getDate();
            if (cy === startYear && cm === startMonth) {
                startDay = this.min.getDate();
            }
            if (cy === endYear && cm === endMonth) {
                endDay = this.max.getDate();
            }
            _selected = 0;
            this._groups.push(Array(endDay - startDay + 1)
                .fill(0)
                .map((/**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */
            (_v, idx) => {
                /** @type {?} */
                const val = startDay + idx;
                if (val === day) {
                    _selected = idx;
                }
                return { label: val + (/** @type {?} */ (this._format.du)), value: val };
            })));
            this._selected.push(_selected);
        }
    }
    /**
     * @private
     * @return {?}
     */
    genDateTimeGroups() {
        /** @type {?} */
        const hours = this._value.getHours();
        /** @type {?} */
        const minutes = this._value.getMinutes();
        // hours
        /** @type {?} */
        let _selected = 0;
        this._groups.push(Array(24)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        (_v, idx) => {
            /** @type {?} */
            const val = idx;
            if (val === hours) {
                _selected = idx;
            }
            return { label: val + (/** @type {?} */ (this._format.hu)), value: val };
        })));
        this._selected.push(_selected);
        // minutes
        _selected = 0;
        this._groups.push(Array(60)
            .fill(0)
            .map((/**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */
        (_v, idx) => {
            /** @type {?} */
            const val = idx;
            if (val === minutes) {
                _selected = idx;
            }
            return { label: val + (/** @type {?} */ (this._format.mu)), value: val };
        })));
        this._selected.push(_selected);
    }
    // 根据selected
    /**
     * @private
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    genValueBySelected() {
        if ((/** @type {?} */ (this)).type === 'time') {
            /** @type {?} */
            const now = new Date();
            (/** @type {?} */ (this))._value = new Date(now.getFullYear(), now.getMonth() + 1, now.getDate(), (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value, (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value, 0);
            return (/** @type {?} */ (this));
        }
        /** @type {?} */
        const obj = {
            y: (/** @type {?} */ (this))._groups[0][(/** @type {?} */ (this))._selected[0]].value,
            M: (/** @type {?} */ (this))._groups[1][(/** @type {?} */ (this))._selected[1]].value - 1,
            d: (/** @type {?} */ (this)).type !== 'date-ym' ? (/** @type {?} */ (this))._groups[2][(/** @type {?} */ (this))._selected[2]].value : 1,
            h: 0,
            m: 0,
            s: 0,
        };
        if (~(/** @type {?} */ (this)).type.indexOf('time')) {
            obj.h = (/** @type {?} */ (this))._groups[3][(/** @type {?} */ (this))._selected[3]].value;
            obj.m = (/** @type {?} */ (this))._groups[4][(/** @type {?} */ (this))._selected[4]].value;
        }
        (/** @type {?} */ (this))._value = new Date(obj.y, obj.M, obj.d, obj.h, obj.m, obj.s);
        return (/** @type {?} */ (this));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._groups.length = 0;
    }
    /**
     * @private
     * @param {?} date
     * @return {?}
     */
    getFormatDate(date) {
        /** @type {?} */
        let f = '';
        if (this._format && this._format.format) {
            f = this._format.format;
        }
        else {
            switch (this.type) {
                case 'date-ym':
                    f = 'yyyy-MM';
                    break;
                case 'date':
                    f = 'yyyy-MM-dd';
                    break;
                case 'datetime':
                    f = 'yyyy-MM-dd HH:mm:ss';
                    break;
                case 'time':
                    f = 'HH:mm';
                    break;
            }
        }
        return (/** @type {?} */ (this.datePipe.transform(date, f)));
    }
    /**
     * @param {?} data
     * @return {?}
     */
    _onChange(data) {
        this.genValueBySelected();
        /** @type {?} */
        const retVal = new Date(this._value.getTime());
        this.onChange(retVal);
        this.onTouched();
        data.value = retVal;
        data.formatValue = this.getFormatDate(retVal);
        this._pickerInstance._text = data.formatValue;
        this.change.emit(data);
    }
    /**
     * @param {?} res
     * @return {?}
     */
    _onGroupChange(res) {
        this._selected[res.groupIndex] = res.index;
        if (res.groupIndex !== this._groups.length - 1) {
            this.genValueBySelected().genGroups();
        }
        this.groupChange.emit(res);
    }
    /**
     * @return {?}
     */
    _onCityCancelChange() {
        this.cancel.emit();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.initFlag = true;
        this.genGroups();
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        if (this.initFlag) {
            this.genGroups();
        }
    }
    /**
     * 服务于Service，并无实际意义
     * @return {?}
     */
    _triggerShow() {
        this._pickerInstance._onShow();
    }
    /**
     * @return {?}
     */
    _onShow() {
        this.show.emit();
    }
    /**
     * @return {?}
     */
    _onHide() {
        this.hide.emit();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (value) {
            this.genGroups();
        }
        this._value = value;
        this._pickerInstance._text = value instanceof Date ? (/** @type {?} */ (this.getFormatDate(value))) : '';
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this.onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
DatePickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-date-picker',
                exportAs: 'weuiDatePicker',
                template: `
    <weui-picker
      [placeholder]="placeholder"
      [groups]="_groups"
      [defaultSelect]="_selected"
      [disabled]="disabled"
      [title]="title"
      [options]="options"
      (show)="_onShow()"
      (hide)="_onHide()"
      (change)="_onChange($event)"
      (groupChange)="_onGroupChange($event)"
      (cancel)="_onCityCancelChange()"
    ></weui-picker>
  `,
                providers: [
                    DatePipe,
                    {
                        provide: NG_VALUE_ACCESSOR,
                        useExisting: forwardRef((/**
                         * @return {?}
                         */
                        () => DatePickerComponent)),
                        multi: true,
                    },
                ],
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
DatePickerComponent.propDecorators = {
    format: [{ type: Input }],
    _pickerInstance: [{ type: ViewChild, args: [PickerComponent, { static: true },] }],
    min: [{ type: Input }],
    max: [{ type: Input }],
    type: [{ type: Input }],
    change: [{ type: Output }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.initFlag;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype._format;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype._pickerInstance;
    /** @type {?} */
    DatePickerComponent.prototype._value;
    /** @type {?} */
    DatePickerComponent.prototype._groups;
    /** @type {?} */
    DatePickerComponent.prototype._selected;
    /**
     * 最小时间范围
     * - 当前只限定年月日，暂不包括时间范围
     * @type {?}
     */
    DatePickerComponent.prototype.min;
    /**
     * 最大时间范围
     * - 当前只限定年月日，暂不包括时间范围
     * @type {?}
     */
    DatePickerComponent.prototype.max;
    /**
     * 类型
     * + `date-ym` 年月
     * + `date` 日期
     * + `datetime` 日期&时间（不包括秒）
     * + `time` 时间（不包括秒）
     * @type {?}
     */
    DatePickerComponent.prototype.type;
    /** @type {?} */
    DatePickerComponent.prototype.change;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.onChange;
    /**
     * @type {?}
     * @private
     */
    DatePickerComponent.prototype.onTouched;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 多列选择器Service，可直接通过Class构造选择器
 */
class PickerService extends BaseService {
    /**
     * @param {?} resolver
     * @param {?} applicationRef
     * @param {?} injector
     * @param {?} doc
     */
    constructor(resolver, applicationRef, injector, doc) {
        super();
        this.resolver = resolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.doc = doc;
    }
    /**
     * @private
     * @param {?} ref
     * @param {?} config
     * @return {?}
     */
    attachBase(ref, config) {
        /** @type {?} */
        const instance = ref.instance;
        const { options, title, placeholder, disabled, value } = config;
        // 通过Service打开的强制设置为 `default` 以免出现 `input`
        config.options = Object.assign(Object.assign({}, options), { type: 'default' });
        instance.options = config.options;
        instance.title = (/** @type {?} */ (title));
        instance.placeholder = (/** @type {?} */ (placeholder));
        instance.disabled = (/** @type {?} */ (disabled));
        if (value) {
            setTimeout((/**
             * @return {?}
             */
            () => instance.writeValue(value)), 100);
        }
        instance.hide.subscribe((/**
         * @return {?}
         */
        () => setTimeout((/**
         * @return {?}
         */
        () => this.destroy(ref)), 100)));
    }
    /**
     * @param {?} config
     * @return {?}
     */
    create(config) {
        const { defaultSelect, data } = config;
        /** @type {?} */
        const componentRef = this.build(PickerComponent);
        /** @type {?} */
        const instance = componentRef.instance;
        if (defaultSelect) {
            instance.defaultSelect = defaultSelect;
        }
        instance.groups = data;
        this.attachBase(componentRef, config);
        instance._onShow();
        return instance.change;
    }
    /**
     * @deprecated Use `create()` instead and going to be removed in 11.0.0
     *
     * 构建一个多列选择器并显示
     * @param {?} data
     * @param {?=} value
     * @param {?=} defaultSelect
     * @param {?=} options
     * @return {?}
     */
    show(data, value, defaultSelect, options) {
        return this.create({ data, value, defaultSelect, options });
    }
    /**
     * 构建一个城市选择器并显示
     * @param {?} config
     * @return {?}
     */
    city(config) {
        const { dataMap, data } = config;
        /** @type {?} */
        const componentRef = this.build(CityPickerComponent);
        /** @type {?} */
        const instance = componentRef.instance;
        if (dataMap) {
            instance.dataMap = dataMap;
        }
        this.attachBase(componentRef, config);
        instance.data = data;
        setTimeout((/**
         * @return {?}
         */
        () => {
            instance._triggerShow();
        }), 200);
        return instance.change;
    }
    /**
     * @deprecated Use `city()` instead and going to be removed in 11.0.0
     *
     * 构建一个城市选择器并显示
     * @param {?} data
     * @param {?=} value
     * @param {?=} dataMap
     * @param {?=} options
     * @return {?}
     */
    showCity(data, value, dataMap, options) {
        return this.city({ data, value, dataMap, options });
    }
    /**
     * 构建一个日期时间选择器并显示
     * @param {?} config
     * @return {?}
     */
    dateTime(config) {
        const { type, format, min, max } = config;
        /** @type {?} */
        const componentRef = this.build(DatePickerComponent);
        /** @type {?} */
        const instance = componentRef.instance;
        this.attachBase(componentRef, config);
        if (type) {
            instance.type = type;
        }
        if (format) {
            instance.format = format;
        }
        if (min) {
            instance.min = min;
        }
        if (max) {
            instance.max = max;
        }
        setTimeout((/**
         * @return {?}
         */
        () => {
            instance.ngOnChanges();
            instance._triggerShow();
        }), 200);
        return instance.change;
    }
    /**
     * @deprecated Use `dateTime()` instead and going to be removed in 11.0.0
     *
     * 构建一个日期时间选择器并显示
     * @param {?=} type
     * @param {?=} format
     * @param {?=} value
     * @param {?=} min
     * @param {?=} max
     * @param {?=} options
     * @return {?}
     */
    showDateTime(type, format, value, min, max, options) {
        return this.dateTime({ type, format, value, min, max, options });
    }
}
PickerService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
PickerService.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: Injector },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ PickerService.ɵprov = ɵɵdefineInjectable({ factory: function PickerService_Factory() { return new PickerService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: PickerService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @protected
     */
    PickerService.prototype.resolver;
    /**
     * @type {?}
     * @protected
     */
    PickerService.prototype.applicationRef;
    /**
     * @type {?}
     * @protected
     */
    PickerService.prototype.injector;
    /**
     * @type {?}
     * @protected
     */
    PickerService.prototype.doc;
}

/**
 * @fileoverview added by tsickle
 * Generated from: picker.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const COMPONENTS = [PickerComponent, PickerGroupComponent, DatePickerComponent, CityPickerComponent];
class PickerModule {
}
PickerModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: COMPONENTS,
                exports: COMPONENTS,
                entryComponents: COMPONENTS,
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-picker.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CityPickerComponent, DatePickerComponent, PickerComponent, PickerConfig, PickerGroupComponent, PickerModule, PickerService, PickerBaseComponent as ɵa };
//# sourceMappingURL=ngx-weui-picker.js.map
