import { trigger, state, style, transition, animate } from '@angular/animations';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ChangeDetectorRef, Output, Input, NgModule } from '@angular/core';
import { Observable, Subscription } from 'rxjs';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: popup.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PopupConfig {
    constructor() {
        /**
         * 是否全屏，默认：`false`
         */
        this.is_full = false;
        /**
         * 取消按钮文本，默认：`取消`
         */
        this.cancel = '取消';
        /**
         * 确定按钮文本，默认：`确定`
         */
        this.confirm = '确定';
        /**
         * 允许点击背景关闭，默认：`true`
         */
        this.backdrop = true;
    }
}
PopupConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ PopupConfig.ɵprov = ɵɵdefineInjectable({ factory: function PopupConfig_Factory() { return new PopupConfig(); }, token: PopupConfig, providedIn: "root" });
if (false) {
    /**
     * 是否全屏，默认：`false`
     * @type {?}
     */
    PopupConfig.prototype.is_full;
    /**
     * 取消按钮文本，默认：`取消`
     * @type {?}
     */
    PopupConfig.prototype.cancel;
    /**
     * 确定按钮文本，默认：`确定`
     * @type {?}
     */
    PopupConfig.prototype.confirm;
    /**
     * 允许点击背景关闭，默认：`true`
     * @type {?}
     */
    PopupConfig.prototype.backdrop;
}

/**
 * @fileoverview added by tsickle
 * Generated from: popup.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PopupComponent {
    /**
     * @param {?} DEF
     * @param {?} cdr
     */
    constructor(DEF, cdr) {
        this.DEF = DEF;
        this.cdr = cdr;
        this.shown = false;
        this._shownAnt = false;
        this.cancel = new EventEmitter();
        this.confirm = new EventEmitter();
        this.config = Object.assign({}, DEF);
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set config(val) {
        this._config = Object.assign(Object.assign({}, this.DEF), val);
    }
    /**
     * @return {?}
     */
    get config() {
        return this._config;
    }
    /**
     * @return {?}
     */
    get _visibility() {
        return this._shownAnt ? 'show' : 'hide';
    }
    /**
     * 显示，并支持订阅结果，如果点击取消值为false，反之 true
     * @return {?}
     */
    show() {
        this.shown = true;
        setTimeout((/**
         * @return {?}
         */
        () => {
            this._shownAnt = true;
            this.cdr.detectChanges();
        }), 10);
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        (observer) => {
            this.observer = observer;
        }));
    }
    /**
     * 隐藏
     *
     * @param {?=} is_backdrop
     * @return {?}
     */
    hide(is_backdrop) {
        if (is_backdrop === true && this.config.backdrop === false) {
            return;
        }
        this._shownAnt = false;
        this.cdr.detectChanges();
        setTimeout((/**
         * @return {?}
         */
        () => {
            this.shown = false;
        }), 300);
    }
    /**
     * 关闭，等同 `hide()` 效果
     * @return {?}
     */
    close() {
        this.hide(false);
    }
    /**
     * @return {?}
     */
    _onCancel() {
        this.cancel.emit();
        this.hide(false);
        if (this.observer) {
            this.observer.next(false);
            this.observer.complete();
        }
        return false;
    }
    /**
     * @return {?}
     */
    _onConfirm() {
        this.confirm.emit();
        this.hide(false);
        if (this.observer) {
            this.observer.next(true);
            this.observer.complete();
        }
        return false;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (this.observer && this.observer instanceof Subscription) {
            this.observer.unsubscribe();
        }
    }
}
PopupComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-popup',
                exportAs: 'weuiPopup',
                template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-popup\" [ngClass]=\"{ 'weui-popup_toggle': _shownAnt }\">\n  <div class=\"weui-popup__hd\" *ngIf=\"!config.is_full\">\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onCancel()\">{{ config.cancel }}</a>\n    <a href=\"#\" class=\"weui-popup__action\" (click)=\"_onConfirm()\">{{ config.confirm }}</a>\n  </div>\n  <div [ngClass]=\"{ 'weui-popup_full': config.is_full }\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                animations: [
                    trigger('visibility', [
                        state('show', style({ opacity: 1 })),
                        state('hide', style({ opacity: 0 })),
                        transition('hide <=> show', [animate(200)]),
                    ]),
                ],
                host: {
                    '[hidden]': '!shown',
                },
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
PopupComponent.ctorParameters = () => [
    { type: PopupConfig },
    { type: ChangeDetectorRef }
];
PopupComponent.propDecorators = {
    cancel: [{ type: Output }],
    confirm: [{ type: Output }],
    config: [{ type: Input }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.observer;
    /** @type {?} */
    PopupComponent.prototype.shown;
    /** @type {?} */
    PopupComponent.prototype._shownAnt;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype._config;
    /** @type {?} */
    PopupComponent.prototype.cancel;
    /** @type {?} */
    PopupComponent.prototype.confirm;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.DEF;
    /**
     * @type {?}
     * @private
     */
    PopupComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: popup.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PopupModule {
}
PopupModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [PopupComponent],
                exports: [PopupComponent],
                entryComponents: [PopupComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-popup.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PopupComponent, PopupConfig, PopupModule };
//# sourceMappingURL=ngx-weui-popup.js.map
