import { __decorate, __metadata } from 'tslib';
import { EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ChangeDetectorRef, Input, Output, NgModule } from '@angular/core';
import { InputBoolean, InputNumber } from 'ngx-weui/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: progress.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ProgressComponent {
    /**
     * @param {?} cdr
     */
    constructor(cdr) {
        this.cdr = cdr;
        this._value = 0;
        /**
         * 是否允许取消，默认：`true`
         */
        this.canCancel = true;
        /**
         * 取消回调
         */
        this.cancel = new EventEmitter();
    }
    /**
     * 默认进度值，取值范围：0-100（单位：%）
     * @param {?} d
     * @return {?}
     */
    set value(d) {
        this._value = Math.max(0, Math.min(100, d));
        this.cdr.detectChanges();
    }
    /**
     * @return {?}
     */
    _onCancel() {
        if (this.canCancel) {
            this.cancel.emit();
        }
        return false;
    }
}
ProgressComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-progress',
                exportAs: 'weuiProgress',
                template: "<div class=\"weui-progress\">\n  <div class=\"weui-progress__bar\">\n    <div class=\"weui-progress__inner-bar\" [style.width]=\"_value + '%'\"></div>\n  </div>\n  <a href=\"#\" class=\"weui-progress__opr\" *ngIf=\"canCancel\" (click)=\"_onCancel()\">\n    <i class=\"weui-icon-cancel\"></i>\n  </a>\n</div>\n",
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
ProgressComponent.ctorParameters = () => [
    { type: ChangeDetectorRef }
];
ProgressComponent.propDecorators = {
    canCancel: [{ type: Input }],
    cancel: [{ type: Output }],
    value: [{ type: Input }]
};
__decorate([
    InputBoolean(),
    __metadata("design:type", Boolean)
], ProgressComponent.prototype, "canCancel", void 0);
__decorate([
    InputNumber(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], ProgressComponent.prototype, "value", null);
if (false) {
    /** @type {?} */
    ProgressComponent.prototype._value;
    /**
     * 是否允许取消，默认：`true`
     * @type {?}
     */
    ProgressComponent.prototype.canCancel;
    /**
     * 取消回调
     * @type {?}
     */
    ProgressComponent.prototype.cancel;
    /**
     * @type {?}
     * @private
     */
    ProgressComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: progress.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ProgressModule {
}
ProgressModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [ProgressComponent],
                exports: [ProgressComponent],
                entryComponents: [ProgressComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-progress.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ProgressComponent, ProgressModule };
//# sourceMappingURL=ngx-weui-progress.js.map
