import { __decorate, __metadata } from 'tslib';
import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, ChangeDetectorRef, Input, Output, NgModule } from '@angular/core';
import { InputBoolean } from 'ngx-weui/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: ptr.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PTRConfig {
    constructor() {
        /**
         * 是否使用默认icon样式，默认：`false`
         */
        this.customIcon = false;
        /**
         * 下拉icon，支持HTML
         */
        this.pullIcon = '<i class="weui-icon-download"></i>';
        /**
         * 加载中icon，支持HTML
         */
        this.loadingIcon = '<i class="weui-loading"></i>';
        /**
         * 加载成功icon，支持HTML
         */
        this.successIcon = '<i class="weui-icon-success"></i>';
        /**
         * 下拉刷新容器高度（单位：px），默认：`100`
         */
        this.height = 100;
        /**
         * 下拉范围有效（单位：%），默认：`80`
         */
        this.treshold = 80;
    }
}
PTRConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ PTRConfig.ɵprov = ɵɵdefineInjectable({ factory: function PTRConfig_Factory() { return new PTRConfig(); }, token: PTRConfig, providedIn: "root" });
if (false) {
    /**
     * 是否使用默认icon样式，默认：`false`
     * @type {?}
     */
    PTRConfig.prototype.customIcon;
    /**
     * 下拉icon，支持HTML
     * @type {?}
     */
    PTRConfig.prototype.pullIcon;
    /**
     * 加载中icon，支持HTML
     * @type {?}
     */
    PTRConfig.prototype.loadingIcon;
    /**
     * 加载成功icon，支持HTML
     * @type {?}
     */
    PTRConfig.prototype.successIcon;
    /**
     * 下拉刷新容器高度（单位：px），默认：`100`
     * @type {?}
     */
    PTRConfig.prototype.height;
    /**
     * 下拉范围有效（单位：%），默认：`80`
     * @type {?}
     */
    PTRConfig.prototype.treshold;
}

/**
 * @fileoverview added by tsickle
 * Generated from: ptr.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PTRComponent {
    /**
     * @param {?} el
     * @param {?} DEF
     * @param {?} cdr
     */
    constructor(el, DEF, cdr) {
        this.el = el;
        this.DEF = DEF;
        this.cdr = cdr;
        this.ogY = 0;
        this.touching = false;
        this.initScrollTop = 0;
        this.loading = false;
        this._animating = false;
        this._pullPercent = 0;
        /**
         * 是否禁止
         */
        this.disabled = false;
        /**
         * 下拉滚动时回调，返回一个0-100%的参数
         */
        this.scroll = new EventEmitter();
        /**
         * 刷新回调
         */
        this.refresh = new EventEmitter();
        this.config = Object.assign({}, DEF);
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set config(val) {
        this._config = Object.assign(Object.assign({}, this.DEF), val);
    }
    /**
     * @return {?}
     */
    get config() {
        return this._config;
    }
    /**
     * @return {?}
     */
    get icon() {
        return this._pullPercent !== 100 ? (/** @type {?} */ (this.config.pullIcon)) : this.loading ? (/** @type {?} */ (this.config.loadingIcon)) : (/** @type {?} */ (this.config.successIcon));
    }
    /**
     * 设置最后更新标签
     *
     * @param {?} label 标签内容（支持HTML）
     * @return {?}
     */
    setLastUpdatedLabel(label) {
        this._lastLabel = label;
        this.cdr.detectChanges();
    }
    /**
     * 设置刷新成功
     *
     * @param {?=} lastUpdatedLabel
     * @return {?}
     */
    setFinished(lastUpdatedLabel) {
        this._pullPercent = 0;
        this.loading = false;
        this._animating = true;
        this.cdr.detectChanges();
        if (!this.touching) {
            setTimeout((/**
             * @return {?}
             */
            () => {
                this._animating = false;
                if (lastUpdatedLabel) {
                    this.setLastUpdatedLabel(lastUpdatedLabel);
                }
                this.cdr.detectChanges();
            }), 350);
        }
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onTouchStart($event) {
        if (this.disabled || this.touching || this.loading) {
            return;
        }
        this.touching = true;
        this.touchId = $event.targetTouches[0].identifier;
        this.ogY = this._pullPercent === 0 ? $event.targetTouches[0].pageY : $event.targetTouches[0].pageY - this._pullPercent;
        this.initScrollTop = this.contentEl.scrollTop;
        this._animating = false;
    }
    /**
     * @param {?} $event
     * @return {?}
     */
    onTouchMove($event) {
        if (this.disabled || !this.touching || this.loading) {
            return;
        }
        if ($event.targetTouches[0].identifier !== this.touchId) {
            return;
        }
        /** @type {?} */
        const pageY = $event.targetTouches[0].pageY;
        /** @type {?} */
        const diffY = pageY - this.ogY;
        // if it's scroll
        if (diffY < 0) {
            return;
        }
        // if it's not at top
        if (this.contentEl.scrollTop > 0) {
            return;
        }
        if ($event.cancelable) {
            $event.preventDefault();
        }
        // let diffY = Math.abs(this.ogY - pageY);
        this._pullPercent = diffY - this.initScrollTop > 100 ? 100 : diffY - this.initScrollTop;
        this.scroll.emit(this._pullPercent);
    }
    /**
     * @return {?}
     */
    onTouchEnd() {
        if (this.disabled || !this.touching || this.loading) {
            return;
        }
        /** @type {?} */
        let _pullPercent = this._pullPercent;
        /** @type {?} */
        let loading = false;
        if (_pullPercent >= (/** @type {?} */ (this.config.treshold))) {
            loading = true;
        }
        else {
            _pullPercent = 0;
        }
        this.touching = false;
        this.ogY = 0;
        this.touchId = undefined;
        this.initScrollTop = 0;
        this._animating = loading;
        this._pullPercent = _pullPercent;
        this.loading = loading;
        if (loading) {
            this.refresh.emit(this);
        }
        this.cdr.detectChanges();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.contentEl = (/** @type {?} */ ((/** @type {?} */ (this.el.nativeElement.querySelector('.weui-ptr__content')))));
    }
}
PTRComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-ptr',
                exportAs: 'weuiPtr',
                template: "<div\n  class=\"weui-ptr__loader\"\n  [ngStyle]=\"{\n    'height.px': config.height,\n    'margin-top.px': -config.height! + _pullPercent / (100 / config.height!),\n    transition: _animating ? 'all .5s' : 'none'\n  }\"\n>\n  <div style=\"flex: 1 1 0%; padding: 5px;\" *ngIf=\"!config.customIcon\">\n    <span\n      [innerHTML]=\"icon\"\n      class=\"weui-ptr__icon\"\n      style=\"display: inline-block;\"\n      [ngStyle]=\"{\n        transform: 'rotate(' + -(_pullPercent !== 100 ? _pullPercent * 1.8 : 0) + 'deg)',\n        color: _pullPercent !== 100 ? '#5f5f5f' : '#1AAD19'\n      }\"\n    ></span>\n    <p *ngIf=\"_lastLabel\" class=\"weui-ptr__label\">{{ _lastLabel }}</p>\n  </div>\n  <ng-content select=\"[loader]\"></ng-content>\n</div>\n<div class=\"weui-ptr__content\">\n  <ng-content></ng-content>\n</div>\n",
                host: {
                    '(touchstart)': 'onTouchStart($event)',
                    '(touchmove)': 'onTouchMove($event)',
                    '(touchend)': 'onTouchEnd()',
                    '(touchcancel)': 'onTouchEnd()',
                    '[class.weui-ptr]': 'true',
                },
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
PTRComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: PTRConfig },
    { type: ChangeDetectorRef }
];
PTRComponent.propDecorators = {
    disabled: [{ type: Input }],
    scroll: [{ type: Output }],
    refresh: [{ type: Output }],
    config: [{ type: Input }]
};
__decorate([
    InputBoolean(),
    __metadata("design:type", Boolean)
], PTRComponent.prototype, "disabled", void 0);
if (false) {
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.ogY;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.touching;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.touchId;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.initScrollTop;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.contentEl;
    /** @type {?} */
    PTRComponent.prototype.loading;
    /** @type {?} */
    PTRComponent.prototype._animating;
    /** @type {?} */
    PTRComponent.prototype._pullPercent;
    /** @type {?} */
    PTRComponent.prototype._lastLabel;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype._config;
    /**
     * 是否禁止
     * @type {?}
     */
    PTRComponent.prototype.disabled;
    /**
     * 下拉滚动时回调，返回一个0-100%的参数
     * @type {?}
     */
    PTRComponent.prototype.scroll;
    /**
     * 刷新回调
     * @type {?}
     */
    PTRComponent.prototype.refresh;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.DEF;
    /**
     * @type {?}
     * @private
     */
    PTRComponent.prototype.cdr;
}

/**
 * @fileoverview added by tsickle
 * Generated from: ptr.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PTRModule {
}
PTRModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [PTRComponent],
                exports: [PTRComponent],
                entryComponents: [PTRComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-ptr.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PTRComponent, PTRConfig, PTRModule };
//# sourceMappingURL=ngx-weui-ptr.js.map
