import { Injectable, ɵɵdefineInjectable, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, NgZone, Input, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SwiperConfig {
    constructor() {
        /**
         * 等同于swiper[参数项](http://idangero.us/swiper/api/)
         */
        this.options = {
            loop: true,
            pagination: '.swiper-pagination',
        };
    }
}
SwiperConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ SwiperConfig.ɵprov = ɵɵdefineInjectable({ factory: function SwiperConfig_Factory() { return new SwiperConfig(); }, token: SwiperConfig, providedIn: "root" });
if (false) {
    /**
     * 等同于swiper[参数项](http://idangero.us/swiper/api/)
     * @type {?}
     */
    SwiperConfig.prototype.options;
}

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SwiperComponent {
    /**
     * @param {?} el
     * @param {?} zone
     * @param {?} DEF
     */
    constructor(el, zone, DEF) {
        this.el = el;
        this.zone = zone;
        this.DEF = DEF;
    }
    /**
     * @private
     * @return {?}
     */
    initOptions() {
        this.options = Object.assign(Object.assign({}, this.DEF.options), this.options);
    }
    /**
     * @private
     * @return {?}
     */
    init() {
        this.destroy();
        this.zone.runOutsideAngular((/**
         * @return {?}
         */
        () => {
            this.swiper = new Swiper(this.containerEl, this.options);
        }));
    }
    /**
     * @private
     * @return {?}
     */
    destroy() {
        if (this.containerEl) {
            ['horizontal', 'vertical'].forEach((/**
             * @param {?} v
             * @return {?}
             */
            v => {
                this.containerEl.classList.remove('swiper-container-' + v);
            }));
        }
        if (this.swiper) {
            this.zone.runOutsideAngular((/**
             * @return {?}
             */
            () => {
                this.swiper.destroy(true, false);
                this.swiper = null;
            }));
        }
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        if (!this.options) {
            this.initOptions();
        }
        this.containerEl = this.el.nativeElement.querySelector('.swiper-container');
        if (!this.containerEl) {
            throw new Error('组件内容的HTML跟swiper所需要的DOM结构必须完全一样。');
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.init();
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.options) {
            this.initOptions();
            if (!changes.options.firstChange) {
                this.init();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
SwiperComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-swiper',
                exportAs: 'weuiSwiper',
                template: ` <ng-content></ng-content> `,
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
SwiperComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: NgZone },
    { type: SwiperConfig }
];
SwiperComponent.propDecorators = {
    options: [{ type: Input }]
};
if (false) {
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.containerEl;
    /**
     * 等同于swiper[参数项](http://idangero.us/swiper/api/)
     * @type {?}
     */
    SwiperComponent.prototype.options;
    /**
     * Swiper 实例对象，可以通过 `\@ViewChild` 访问到它
     * @type {?}
     */
    SwiperComponent.prototype.swiper;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.zone;
    /**
     * @type {?}
     * @private
     */
    SwiperComponent.prototype.DEF;
}

/**
 * @fileoverview added by tsickle
 * Generated from: swiper.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class SwiperModule {
}
SwiperModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [SwiperComponent],
                exports: [SwiperComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-swiper.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { SwiperComponent, SwiperConfig, SwiperModule };
//# sourceMappingURL=ngx-weui-swiper.js.map
