import { __decorate, __metadata } from 'tslib';
import { EventEmitter, Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, Input, Output, Injectable, ComponentFactoryResolver, ApplicationRef, Injector, Inject, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { UpdateHostClassService, InputNumber, BaseService } from 'ngx-weui/core';
import { DOCUMENT, CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ToptipsComponent {
    /**
     * @param {?} el
     * @param {?} uhcs
     */
    constructor(el, uhcs) {
        this.el = el;
        this.uhcs = uhcs;
        this._showd = false;
        /**
         * 显示时长后自动关闭（单位：ms），默认：`2000`
         */
        this.time = 2000;
        /**
         * 类型
         */
        this.type = 'primary';
        /**
         * 隐藏后回调
         */
        this.hide = new EventEmitter();
    }
    /**
     * @private
     * @return {?}
     */
    setClassMap() {
        /** @type {?} */
        const prefixCls = 'weui-toptips';
        const { uhcs, el, type } = this;
        uhcs.updateHostClass(el.nativeElement, {
            [`${prefixCls}`]: true,
            [`${prefixCls}__${type}`]: true,
        });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.setClassMap();
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.setClassMap();
    }
    /**
     * @template THIS
     * @this {THIS}
     * @return {THIS}
     */
    onShow() {
        (/** @type {?} */ (this)).destroy();
        (/** @type {?} */ (this))._showd = true;
        (/** @type {?} */ (this)).timer = setTimeout((/**
         * @return {?}
         */
        () => (/** @type {?} */ (this)).onHide()), (/** @type {?} */ (this)).time);
        return (/** @type {?} */ (this));
    }
    /**
     * @return {?}
     */
    onHide() {
        this._showd = false;
        this.hide.emit();
    }
    /**
     * @private
     * @return {?}
     */
    destroy() {
        if (this.timer) {
            clearTimeout(this.timer);
            this.timer = null;
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.destroy();
    }
}
ToptipsComponent.decorators = [
    { type: Component, args: [{
                selector: 'weui-toptips',
                exportAs: 'weuiToptips',
                template: ` {{ text }}<ng-content></ng-content> `,
                host: {
                    '[hidden]': '!_showd',
                    '[style.display]': '_showd ? "block" : "none"',
                },
                providers: [UpdateHostClassService],
                preserveWhitespaces: false,
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None
            }] }
];
/** @nocollapse */
ToptipsComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: UpdateHostClassService }
];
ToptipsComponent.propDecorators = {
    text: [{ type: Input }],
    time: [{ type: Input }],
    type: [{ type: Input }],
    hide: [{ type: Output }]
};
__decorate([
    InputNumber(),
    __metadata("design:type", Number)
], ToptipsComponent.prototype, "time", void 0);
if (false) {
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.timer;
    /** @type {?} */
    ToptipsComponent.prototype._showd;
    /**
     * 文本
     * @type {?}
     */
    ToptipsComponent.prototype.text;
    /**
     * 显示时长后自动关闭（单位：ms），默认：`2000`
     * @type {?}
     */
    ToptipsComponent.prototype.time;
    /**
     * 类型
     * @type {?}
     */
    ToptipsComponent.prototype.type;
    /**
     * 隐藏后回调
     * @type {?}
     */
    ToptipsComponent.prototype.hide;
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    ToptipsComponent.prototype.uhcs;
}

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ToptipsService extends BaseService {
    /**
     * @param {?} resolver
     * @param {?} applicationRef
     * @param {?} injector
     * @param {?} doc
     */
    constructor(resolver, applicationRef, injector, doc) {
        super();
        this.resolver = resolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.doc = doc;
    }
    /**
     * 构建一个Toptips并显示
     *
     * @param {?} text 文本
     * @param {?} type 类型
     * @param {?=} time
     * @return {?}
     */
    show(text, type, time = 2000) {
        /** @type {?} */
        const componentRef = this.build(ToptipsComponent);
        if (type) {
            componentRef.instance.type = type;
        }
        if (text) {
            componentRef.instance.text = text;
        }
        componentRef.instance.time = time;
        componentRef.instance.hide.subscribe((/**
         * @return {?}
         */
        () => {
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.destroy(componentRef);
            }), 100);
        }));
        return componentRef.instance.onShow();
    }
    /**
     * 构建一个Warn Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    warn(text, time = 2000) {
        return this.show(text, 'warn', time);
    }
    /**
     * 构建一个Info Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    info(text, time = 2000) {
        return this.show(text, 'info', time);
    }
    /**
     * 构建一个Primary Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    primary(text, time = 2000) {
        return this.show(text, 'primary', time);
    }
    /**
     * 构建一个Success Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    success(text, time = 2000) {
        return this.show(text, 'primary', time);
    }
    /**
     * 构建一个Default Toptips并显示
     *
     * @param {?} text 文本
     * @param {?=} time 显示时长后自动关闭（单位：ms）
     * @return {?}
     */
    default(text, time = 2000) {
        return this.show(text, 'default', time);
    }
}
ToptipsService.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */
ToptipsService.ctorParameters = () => [
    { type: ComponentFactoryResolver },
    { type: ApplicationRef },
    { type: Injector },
    { type: undefined, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
];
/** @nocollapse */ ToptipsService.ɵprov = ɵɵdefineInjectable({ factory: function ToptipsService_Factory() { return new ToptipsService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: ToptipsService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @protected
     */
    ToptipsService.prototype.resolver;
    /**
     * @type {?}
     * @protected
     */
    ToptipsService.prototype.applicationRef;
    /**
     * @type {?}
     * @protected
     */
    ToptipsService.prototype.injector;
    /**
     * @type {?}
     * @protected
     */
    ToptipsService.prototype.doc;
}

/**
 * @fileoverview added by tsickle
 * Generated from: toptips.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ToptipsModule {
}
ToptipsModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [ToptipsComponent],
                exports: [ToptipsComponent],
                entryComponents: [ToptipsComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-toptips.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ToptipsComponent, ToptipsModule, ToptipsService };
//# sourceMappingURL=ngx-weui-toptips.js.map
