import { Injectable, ɵɵdefineInjectable, Inject, Optional, Directive, Input, ElementRef, NgModule } from '@angular/core';
import { genImageUrl } from 'ngx-weui/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: interface.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: file-like-object.class.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} node
 * @return {?}
 */
function isElement(node) {
    return !!(node && (node.nodeName || (node.prop && node.attr && node.find)));
}
class FileLikeObject {
    /**
     * @param {?} fileOrInput
     */
    constructor(fileOrInput) {
        /** @type {?} */
        const isInput = isElement(fileOrInput);
        /** @type {?} */
        const fakePathOrObject = isInput ? fileOrInput.value : fileOrInput;
        /** @type {?} */
        const postfix = typeof fakePathOrObject === 'string' ? 'FakePath' : 'Object';
        /** @type {?} */
        const method = '_createFrom' + postfix;
        ((/** @type {?} */ (this)))[method](fakePathOrObject);
    }
    /**
     * @param {?} path
     * @return {?}
     */
    _createFromFakePath(path) {
        this.lastModifiedDate = void 0;
        this.size = void 0;
        this.type = 'like/' + path.slice(path.lastIndexOf('.') + 1).toLowerCase();
        this.name = path.slice(path.lastIndexOf('/') + path.lastIndexOf('\\') + 2);
    }
    /**
     * @param {?} object
     * @return {?}
     */
    _createFromObject(object) {
        // this.lastModifiedDate = copy(object.lastModifiedDate);
        this.size = object.size;
        this.type = object.type;
        this.name = object.name;
    }
}
if (false) {
    /** @type {?} */
    FileLikeObject.prototype.id;
    /** @type {?} */
    FileLikeObject.prototype.lastModifiedDate;
    /** @type {?} */
    FileLikeObject.prototype.size;
    /** @type {?} */
    FileLikeObject.prototype.type;
    /** @type {?} */
    FileLikeObject.prototype.name;
}

/**
 * @fileoverview added by tsickle
 * Generated from: file-item.class.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 文件对象
 */
class FileItem {
    /**
     * @param {?} uploader
     * @param {?} file
     * @param {?} options
     */
    constructor(uploader, file, options) {
        /**
         * 索引
         */
        this.index = 0;
        /**
         * 上传进度
         */
        this.progress = 0;
        /**
         * 准备上传就绪
         */
        this.isReady = false;
        /**
         * 上传中
         */
        this.isUploading = false;
        /**
         * 已上传（不管错误与否都是true）
         */
        this.isUploaded = false;
        /**
         * 上传成功
         */
        this.isSuccess = false;
        /**
         * 用户取消上传
         */
        this.isCancel = false;
        /**
         * 上传失败
         */
        this.isError = false;
        this.uploader = uploader;
        this.setOptions(options);
        this.id = Math.random().toString(36).substring(7);
        this.file = new FileLikeObject(file);
        this._file = file;
    }
    /**
     * @param {?} options
     * @return {?}
     */
    setOptions(options) {
        this.options = Object.assign(Object.assign({}, this.uploader.options), options);
    }
    /**
     * 上传
     * @return {?}
     */
    upload() {
        try {
            this.uploader.uploadItem(this);
        }
        catch (e) {
            this.uploader._onCompleteItem(this, '', 0, {});
            this.uploader._onErrorItem(this, '', 0, {});
        }
    }
    /**
     * 取消上传
     * @return {?}
     */
    cancel() {
        this.uploader.cancelItem(this);
    }
    /**
     * 从队列中移除，当文件正在上传中时会先取消
     * @return {?}
     */
    remove() {
        this.uploader.removeFromQueue(this);
    }
    /**
     * @return {?}
     */
    _prepareToUploading() {
        this.index = this.index || this.uploader._getNextIndex();
        this.isReady = true;
    }
    /**
     * @return {?}
     */
    _onBeforeUpload() {
        this.isReady = true;
        this.isUploading = true;
        this.isUploaded = false;
        this.isSuccess = false;
        this.isCancel = false;
        this.isError = false;
        this.progress = 0;
        if (this.options.onUploadStart) {
            this.options.onUploadStart(this);
        }
    }
    /**
     * @param {?} progress
     * @return {?}
     */
    _onProgress(progress) {
        this.progress = progress;
        if (this.options.onUploadProgress) {
            this.options.onUploadProgress(this, progress, this.uploader.progress);
        }
    }
    /**
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onSuccess(response, status, headers) {
        this.isReady = false;
        this.isUploading = false;
        this.isUploaded = true;
        this.isSuccess = true;
        this.isCancel = false;
        this.isError = false;
        this.progress = 100;
        this.index = 0;
        if (this.options.onUploadSuccess) {
            this.options.onUploadSuccess(this, response, status, headers);
        }
    }
    /**
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onError(response, status, headers) {
        this.isReady = false;
        this.isUploading = false;
        this.isUploaded = true;
        this.isSuccess = false;
        this.isCancel = false;
        this.isError = true;
        this.progress = 0;
        this.index = 0;
        if (this.options.onUploadError) {
            this.options.onUploadError(this, response, status, headers);
        }
    }
    /**
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onComplete(response, status, headers) {
        if (this.uploader.options.removeAfterUpload) {
            this.remove();
        }
        if (this.options.onUploadComplete) {
            this.options.onUploadComplete(this, response, status, headers);
        }
    }
    /**
     * @return {?}
     */
    _onCancel() {
        this.isReady = false;
        this.isUploading = false;
        this.isUploaded = false;
        this.isSuccess = false;
        this.isCancel = true;
        this.isError = false;
        this.progress = 0;
        this.index = 0;
        if (this.options.onUploadCancel) {
            this.options.onUploadCancel(this);
        }
    }
}
if (false) {
    /**
     * 文件ID，每个对象具有唯一ID，与文件名无关
     * @type {?}
     */
    FileItem.prototype.id;
    /**
     * 重建文件结构对象
     * @type {?}
     */
    FileItem.prototype.file;
    /**
     * 原生对象
     * @type {?}
     */
    FileItem.prototype._file;
    /**
     * 索引
     * @type {?}
     */
    FileItem.prototype.index;
    /**
     * 上传进度
     * @type {?}
     */
    FileItem.prototype.progress;
    /**
     * 准备上传就绪
     * @type {?}
     */
    FileItem.prototype.isReady;
    /**
     * 上传中
     * @type {?}
     */
    FileItem.prototype.isUploading;
    /**
     * 已上传（不管错误与否都是true）
     * @type {?}
     */
    FileItem.prototype.isUploaded;
    /**
     * 上传成功
     * @type {?}
     */
    FileItem.prototype.isSuccess;
    /**
     * 用户取消上传
     * @type {?}
     */
    FileItem.prototype.isCancel;
    /**
     * 上传失败
     * @type {?}
     */
    FileItem.prototype.isError;
    /**
     * HTTP请求对象
     * @type {?}
     */
    FileItem.prototype._xhr;
    /**
     * 上传配置信息
     * @type {?}
     */
    FileItem.prototype.options;
    /**
     * @type {?}
     * @protected
     */
    FileItem.prototype.uploader;
}

/**
 * @fileoverview added by tsickle
 * Generated from: file-type.class.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FileType {
    /**
     * @param {?} file
     * @return {?}
     */
    static getMimeClass(file) {
        /** @type {?} */
        let mimeClass = 'application';
        if (this.mime_psd.indexOf(file.type) !== -1) {
            mimeClass = 'image';
        }
        else if (file.type.match('image.*')) {
            mimeClass = 'image';
        }
        else if (file.type.match('video.*')) {
            mimeClass = 'video';
        }
        else if (file.type.match('audio.*')) {
            mimeClass = 'audio';
        }
        else if (file.type === 'application/pdf') {
            mimeClass = 'pdf';
        }
        else if (this.mime_compress.indexOf(file.type) !== -1) {
            mimeClass = 'compress';
        }
        else if (this.mime_doc.indexOf(file.type) !== -1) {
            mimeClass = 'doc';
        }
        else if (this.mime_xsl.indexOf(file.type) !== -1) {
            mimeClass = 'xls';
        }
        else if (this.mime_ppt.indexOf(file.type) !== -1) {
            mimeClass = 'ppt';
        }
        if (mimeClass === 'application') {
            mimeClass = this.fileTypeDetection(file.name);
        }
        return mimeClass;
    }
    /**
     * @param {?} inputFilename
     * @return {?}
     */
    static fileTypeDetection(inputFilename) {
        /** @type {?} */
        const types = {
            jpg: 'image',
            jpeg: 'image',
            tif: 'image',
            psd: 'image',
            bmp: 'image',
            png: 'image',
            nef: 'image',
            tiff: 'image',
            cr2: 'image',
            dwg: 'image',
            cdr: 'image',
            ai: 'image',
            indd: 'image',
            pin: 'image',
            cdp: 'image',
            skp: 'image',
            stp: 'image',
            '3dm': 'image',
            mp3: 'audio',
            wav: 'audio',
            wma: 'audio',
            mod: 'audio',
            m4a: 'audio',
            compress: 'compress',
            rar: 'compress',
            '7z': 'compress',
            lz: 'compress',
            z01: 'compress',
            pdf: 'pdf',
            xls: 'xls',
            xlsx: 'xls',
            ods: 'xls',
            mp4: 'video',
            avi: 'video',
            wmv: 'video',
            mpg: 'video',
            mts: 'video',
            flv: 'video',
            '3gp': 'video',
            vob: 'video',
            m4v: 'video',
            mpeg: 'video',
            m2ts: 'video',
            mov: 'video',
            doc: 'doc',
            docx: 'doc',
            eps: 'doc',
            txt: 'doc',
            odt: 'doc',
            rtf: 'doc',
            ppt: 'ppt',
            pptx: 'ppt',
            pps: 'ppt',
            ppsx: 'ppt',
            odp: 'ppt',
        };
        /** @type {?} */
        const chunks = inputFilename.split('.');
        if (chunks.length < 2) {
            return 'application';
        }
        /** @type {?} */
        const extension = chunks[chunks.length - 1].toLowerCase();
        if (types[extension] === undefined) {
            return 'application';
        }
        else {
            return types[extension];
        }
    }
}
/*  MS office  */
FileType.mime_doc = [
    'application/msword',
    'application/msword',
    'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
    'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
    'application/vnd.ms-word.document.macroEnabled.12',
    'application/vnd.ms-word.template.macroEnabled.12',
];
FileType.mime_xsl = [
    'application/vnd.ms-excel',
    'application/vnd.ms-excel',
    'application/vnd.ms-excel',
    'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
    'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
    'application/vnd.ms-excel.sheet.macroEnabled.12',
    'application/vnd.ms-excel.template.macroEnabled.12',
    'application/vnd.ms-excel.addin.macroEnabled.12',
    'application/vnd.ms-excel.sheet.binary.macroEnabled.12',
];
FileType.mime_ppt = [
    'application/vnd.ms-powerpoint',
    'application/vnd.ms-powerpoint',
    'application/vnd.ms-powerpoint',
    'application/vnd.ms-powerpoint',
    'application/vnd.openxmlformats-officedocument.presentationml.presentation',
    'application/vnd.openxmlformats-officedocument.presentationml.template',
    'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
    'application/vnd.ms-powerpoint.addin.macroEnabled.12',
    'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
    'application/vnd.ms-powerpoint.presentation.macroEnabled.12',
    'application/vnd.ms-powerpoint.slideshow.macroEnabled.12',
];
/* PSD */
FileType.mime_psd = [
    'image/photoshop',
    'image/x-photoshop',
    'image/psd',
    'application/photoshop',
    'application/psd',
    'zz-application/zz-winassoc-psd',
];
/* Compressed files */
FileType.mime_compress = [
    'application/x-gtar',
    'application/x-gcompress',
    'application/compress',
    'application/x-tar',
    'application/x-rar-compressed',
    'application/octet-stream',
];
if (false) {
    /** @type {?} */
    FileType.mime_doc;
    /** @type {?} */
    FileType.mime_xsl;
    /** @type {?} */
    FileType.mime_ppt;
    /** @type {?} */
    FileType.mime_psd;
    /** @type {?} */
    FileType.mime_compress;
}

/**
 * @fileoverview added by tsickle
 * Generated from: uploader.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UploaderConfig {
    constructor() {
        /**
         * 发送凭据，默认：`true`
         */
        this.withCredentials = true;
        /**
         * 是否自动上传，默认：`false`
         * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
         */
        this.auto = false;
        /**
         * 允许最多上传数量，-1 表示不受限，默认：`-1`
         */
        this.limit = -1;
        /**
         * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
         */
        this.size = -1;
    }
}
UploaderConfig.decorators = [
    { type: Injectable, args: [{ providedIn: 'root' },] }
];
/** @nocollapse */ UploaderConfig.ɵprov = ɵɵdefineInjectable({ factory: function UploaderConfig_Factory() { return new UploaderConfig(); }, token: UploaderConfig, providedIn: "root" });
if (false) {
    /**
     * 服务端网址
     * @type {?}
     */
    UploaderConfig.prototype.url;
    /**
     * HTTP请求方式
     * @type {?}
     */
    UploaderConfig.prototype.method;
    /**
     * 设置文件上传域的name
     * @type {?}
     */
    UploaderConfig.prototype.alias;
    /**
     * 发送凭据，默认：`true`
     * @type {?}
     */
    UploaderConfig.prototype.withCredentials;
    /**
     * headers 信息
     * @type {?}
     */
    UploaderConfig.prototype.headers;
    /**
     * 是否自动上传，默认：`false`
     * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
     * @type {?}
     */
    UploaderConfig.prototype.auto;
    /**
     * 限定文件mime类型，例如：[ '' ]
     * @type {?}
     */
    UploaderConfig.prototype.mimes;
    /**
     * 限定文件类型，例如：[ 'jpg', 'png' ]
     * @type {?}
     */
    UploaderConfig.prototype.types;
    /**
     * 允许最多上传数量，-1 表示不受限，默认：`-1`
     * @type {?}
     */
    UploaderConfig.prototype.limit;
    /**
     * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
     * @type {?}
     */
    UploaderConfig.prototype.size;
}

/**
 * @fileoverview added by tsickle
 * Generated from: uploader.options.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 组件Header对象接口
 * @record
 */
function UploaderHeaders() { }
if (false) {
    /** @type {?} */
    UploaderHeaders.prototype.name;
    /** @type {?} */
    UploaderHeaders.prototype.value;
}
/**
 * 组件配置项对象接口
 * @record
 */
function UploaderOptions() { }
if (false) {
    /**
     * 服务端网址
     * @type {?|undefined}
     */
    UploaderOptions.prototype.url;
    /**
     * HTTP请求方式，默认：`POST`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.method;
    /**
     * 设置文件上传域的name
     * @type {?|undefined}
     */
    UploaderOptions.prototype.alias;
    /**
     * 是否发送凭据，默认：`true`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.withCredentials;
    /**
     * headers 信息
     * @type {?|undefined}
     */
    UploaderOptions.prototype.headers;
    /**
     * HTTP提交其他参数
     * @type {?|undefined}
     */
    UploaderOptions.prototype.params;
    /**
     * 过滤器
     * @type {?|undefined}
     */
    UploaderOptions.prototype.filters;
    /**
     * 是否自动上传，默认：`false`
     * 设置为 true 后，不需要手动调用 `upload`，有文件选择即开始上传。
     * @type {?|undefined}
     */
    UploaderOptions.prototype.auto;
    /**
     * 限定文件mime类型，例如：[ '' ]
     * @type {?|undefined}
     */
    UploaderOptions.prototype.mimes;
    /**
     * 限定文件类型，例如：[ 'jpg', 'png' ]
     * @type {?|undefined}
     */
    UploaderOptions.prototype.types;
    /**
     * 允许最多上传数量，-1 表示不受限，默认：`-1`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.limit;
    /**
     * 限定文件大小（单位：字节），-1 表示不受限，默认：`-1`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.size;
    /**
     * 是否自动移除上传成功文件，默认：`false`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.removeAfterUpload;
    /**
     * 禁止使用multipart/form-data，默认：`false`
     * @type {?|undefined}
     */
    UploaderOptions.prototype.disableMultipart;
    /**
     * 当文件被加入队列以后触发
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onFileQueued;
    /**
     * 当文件被移除队列后触发
     *
     * \@param file File对象，如果是clear则file为空
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onFileDequeued;
    /**
     * 当开始上传流程时触发
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onStart;
    /**
     * 当开始上传流程取消时触发
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onCancel;
    /**
     * 当所有文件上传结束时触发
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onFinished;
    /**
     * 某个文件开始上传前触发，一个文件只会触发一次
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadStart;
    /**
     * 上传过程中触发，携带总的上传进度，以及当前文件的上传进度
     * \@param file File对象
     * \@param percentage 当前文件上传进度
     * \@param totaoPercentage 总上传进度
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadProgress;
    /**
     * 当文件上传成功时触发
     * \@param file File对象
     * \@param response 服务端返回的数据
     * \@param status 状态码
     * \@param headers Headers
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadSuccess;
    /**
     * 当文件上传出错时触发
     * \@param file File对象
     * \@param response 服务端返回的数据
     * \@param status 状态码
     * \@param headers Headers
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadError;
    /**
     * 不管成功或者失败，文件上传完成时触发
     * \@param file File对象
     * \@param response 服务端返回的数据
     * \@param status 状态码
     * \@param headers Headers
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadComplete;
    /**
     * 取消某文件时触发
     *
     * \@param file File对象
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onUploadCancel;
    /**
     * 当filters不通过时触发
     * \@param file 文件对象
     * \@param filter 过滤器
     * \@param options 选项
     * @type {?|undefined}
     */
    UploaderOptions.prototype.onError;
    /**
     * 内置的上传组件是基于HTML5
     * 如有特殊需求可以自定义上传接口（Observable<any> 中的 any 指的是事件当中的response）
     * 不管成功与否都会触发 onUploadComplete & onUploadSuccess
     * @param {?} item
     * @return {?}
     */
    UploaderOptions.prototype.uploadTransport = function (item) { };
    /**
     * 自定义上传接口，当用户中止时回调
     * @param {?} item
     * @return {?}
     */
    UploaderOptions.prototype.abortTransport = function (item) { };
}

/**
 * @fileoverview added by tsickle
 * Generated from: uploader.class.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 内置HTML5上传组件
 */
class Uploader {
    /**
     * Creates an instance of Uploader.
     * @param {?} options
     * @param {?=} globalConfig
     */
    constructor(options, globalConfig) {
        this.globalConfig = globalConfig;
        this._queue = [];
        this._progress = 0;
        this._isUploading = false;
        this._nextIndex = 0;
        this.setOptions(options);
    }
    /**
     * 获取当前上传组件配置项
     * @return {?}
     */
    get options() {
        return this._options;
    }
    /**
     * 获取队列中所有文件对象
     * @return {?}
     */
    get queue() {
        return this._queue;
    }
    /**
     * 获取当前总进度
     * @return {?}
     */
    get progress() {
        return this._progress;
    }
    /**
     * 是否上传中
     * @return {?}
     */
    get isUploading() {
        return this._isUploading;
    }
    /**
     * 获取未上传数量
     * @return {?}
     */
    get notUploadedCount() {
        return this.getNotUploadedItems().length;
    }
    /**
     * 获取已上传数量
     * @return {?}
     */
    get uploadedCount() {
        return this._queue.filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => item.isUploaded)).length;
    }
    /**
     * 获取待上传文件
     * @return {?}
     */
    get getReadyItems() {
        return this._queue
            .filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => item.isReady && !item.isUploading))
            .sort((/**
         * @param {?} item1
         * @param {?} item2
         * @return {?}
         */
        (item1, item2) => item1.index - item2.index));
    }
    /**
     * @return {?}
     */
    _getNextIndex() {
        return ++this._nextIndex;
    }
    /**
     * 重置选项
     *
     * @param {?} options
     * @param {?=} includeOldQueue 是否包括已存在队列中的文件
     * @return {?}
     */
    setOptions(options, includeOldQueue = true) {
        this._options = (/** @type {?} */ (Object.assign(Object.assign(Object.assign({ filters: [], disableMultipart: false, method: 'POST', alias: 'file', withCredentials: true, auto: false, limit: -1, size: -1, removeAfterUpload: false }, this.globalConfig), this._options), options)));
        // 数量
        if (this._options.limit !== -1) {
            (/** @type {?} */ (this._options.filters)).unshift({
                name: 'queueLimit',
                fn: this._queueLimitFilter,
            });
        }
        // 大小
        if (this._options.size !== -1) {
            (/** @type {?} */ (this._options.filters)).unshift({
                name: 'fileSize',
                fn: this._fileSizeFilter,
            });
        }
        // 类型
        if (this._options.types) {
            (/** @type {?} */ (this._options.filters)).unshift({
                name: 'fileType',
                fn: this._fileTypeFilter,
            });
        }
        // mime类型
        if (this._options.mimes) {
            (/** @type {?} */ (this._options.filters)).unshift({
                name: 'mimeType',
                fn: this._mimeTypeFilter,
            });
        }
        // 对已经存在的队列重置所有配置信息
        if (includeOldQueue) {
            // tslint:disable-next-line: prefer-for-of
            for (let i = 0; i < this._queue.length; i++) {
                this._queue[i].setOptions(this._options);
            }
        }
    }
    /**
     * @private
     * @return {?}
     */
    _queueLimitFilter() {
        return this._options.limit === undefined || this._queue.length < this._options.limit;
    }
    /**
     * @private
     * @param {?=} item
     * @param {?=} _options
     * @return {?}
     */
    _fileSizeFilter(item, _options) {
        return !(this._options.size && (/** @type {?} */ (item)).size > this._options.size);
    }
    /**
     * @private
     * @param {?=} item
     * @param {?=} _options
     * @return {?}
     */
    _mimeTypeFilter(item, _options) {
        return !(this._options.mimes && this._options.mimes.indexOf((/** @type {?} */ (item)).type) === -1);
    }
    /**
     * @private
     * @param {?=} item
     * @param {?=} _options
     * @return {?}
     */
    _fileTypeFilter(item, _options) {
        return !(this._options.types && this._options.types.indexOf(FileType.getMimeClass((/** @type {?} */ (item)))) === -1);
    }
    /**
     * @private
     * @param {?} file
     * @param {?} filters
     * @param {?} options
     * @return {?}
     */
    _isValidFile(file, filters, options) {
        this._failFilterIndex = -1;
        return !filters.length
            ? true
            : filters.every((/**
             * @param {?} filter
             * @return {?}
             */
            (filter) => {
                this._failFilterIndex++;
                return filter.fn.call(this, file, options);
            }));
    }
    /**
     * 过滤器，如果未指定采用内置
     * @private
     * @param {?} filters
     * @return {?}
     */
    _getFilters(filters) {
        if (!filters) {
            return (/** @type {?} */ (this._options.filters));
        }
        if (Array.isArray(filters)) {
            return filters;
        }
        if (typeof filters === 'string') {
            /** @type {?} */
            const names = (/** @type {?} */ (filters.match(/[^\s,]+/g)));
            return (/** @type {?} */ (this._options.filters)).filter((/**
             * @param {?} filter
             * @return {?}
             */
            (filter) => names.indexOf(filter.name) !== -1));
        }
        return (/** @type {?} */ (this._options.filters));
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    _getIndexOfItem(value) {
        return typeof value === 'number' ? value : this._queue.indexOf(value);
    }
    /**
     * 获取未上传过列表
     * @private
     * @return {?}
     */
    getNotUploadedItems() {
        return this._queue.filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => !item.isUploaded));
    }
    /**
     * 将文件放入队列中
     *
     * @param {?} files 文件列表
     * @param {?=} options 强制重新指定新 `options` 内容
     * @param {?=} filters 强制重新指定新 `filters` 内容
     * @return {?}
     */
    addToQueue(files, options, filters) {
        /** @type {?} */
        const list = [];
        for (const file of files) {
            list.push(file);
        }
        /** @type {?} */
        const arrayOfFilters = this._getFilters((/** @type {?} */ (filters)));
        /** @type {?} */
        const count = this._queue.length;
        /** @type {?} */
        const addedFileItems = [];
        if (!options) {
            options = this._options;
        }
        list.forEach((/**
         * @param {?} some
         * @param {?} index
         * @return {?}
         */
        (some, index) => {
            /** @type {?} */
            const temp = new FileLikeObject(some);
            if (this._isValidFile(temp, arrayOfFilters, (/** @type {?} */ (options)))) {
                /** @type {?} */
                const fileItem = new FileItem(this, some, (/** @type {?} */ (options)));
                fileItem.index = index;
                addedFileItems.push(fileItem);
                this._queue.push(fileItem);
                if (this._options.onFileQueued) {
                    this._options.onFileQueued(fileItem);
                }
            }
            else {
                /** @type {?} */
                const filter = arrayOfFilters[this._failFilterIndex];
                if (this._options.onError) {
                    this._options.onError(temp, filter, (/** @type {?} */ (options)));
                }
            }
        }));
        if (this.queue.length !== count) {
            this._progress = this._getTotalProgress();
        }
        if ((/** @type {?} */ (this.options)).auto) {
            this.uploadAll();
        }
    }
    /**
     * 从队列中移除一个文件
     *
     * @param {?} value FileItem对象或下标
     * @return {?}
     */
    removeFromQueue(value) {
        /** @type {?} */
        const index = this._getIndexOfItem(value);
        /** @type {?} */
        const item = this._queue[index];
        if (item.isUploading) {
            item.cancel();
        }
        this._queue.splice(index, 1);
        this._progress = this._getTotalProgress();
        if (this._options.onFileDequeued) {
            this._options.onFileDequeued(item);
        }
    }
    /**
     * 清空队列
     * @return {?}
     */
    clearQueue() {
        while (this._queue.length) {
            this._queue[0].remove();
        }
        this._progress = 0;
        if (this._options.onFileDequeued) {
            this._options.onFileDequeued();
        }
    }
    /**
     * 上传某个文件
     * @param {?} value
     * @return {?}
     */
    uploadItem(value) {
        /** @type {?} */
        const index = this._getIndexOfItem(value);
        /** @type {?} */
        const item = this._queue[index];
        item._prepareToUploading();
        if (this._isUploading) {
            return;
        }
        this._isUploading = true;
        this._xhrTransport(item);
    }
    /**
     * 取消某个文件
     * @param {?} value
     * @return {?}
     */
    cancelItem(value) {
        /** @type {?} */
        const index = this._getIndexOfItem(value);
        /** @type {?} */
        const item = this._queue[index];
        if (item && item.isUploading) {
            if (item.options.abortTransport) {
                this._onCancelItem(item);
                this._onCompleteItem(item, (/** @type {?} */ (null)), (/** @type {?} */ (null)), (/** @type {?} */ (null)));
                item.options.abortTransport(item);
            }
            else {
                if (item._xhr) {
                    item._xhr.abort();
                }
            }
        }
    }
    /**
     * 上传队列中所有未上传的文件
     * @return {?}
     */
    uploadAll() {
        /** @type {?} */
        const items = this.getNotUploadedItems().filter((/**
         * @param {?} item
         * @return {?}
         */
        (item) => !item.isUploading));
        if (!items.length) {
            return;
        }
        items.map((/**
         * @param {?} item
         * @return {?}
         */
        (item) => item._prepareToUploading()));
        if (this._options.onStart) {
            this._options.onStart(items[0]);
        }
        items[0].upload();
    }
    /**
     * 取消所有上传中文件
     * @return {?}
     */
    cancelAll() {
        /** @type {?} */
        const items = this.getNotUploadedItems();
        items.map((/**
         * @param {?} item
         * @return {?}
         */
        (item) => item.cancel()));
        if (this._options.onCancel) {
            this._options.onCancel();
        }
    }
    /**
     * @return {?}
     */
    _destroy() {
        return void 0;
    }
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    _xhrTransport(item) {
        item._onBeforeUpload();
        // 自实现
        if (item.options.uploadTransport) {
            item.options.uploadTransport.apply(this, [item]).subscribe((/**
             * @param {?} response
             * @return {?}
             */
            (response) => {
                this._onSuccessItem(item, response, 0, (/** @type {?} */ (null)));
                this._onCompleteItem(item, response, 0, (/** @type {?} */ (null)));
            }));
            return this;
        }
        /** @type {?} */
        const xhr = (item._xhr = new XMLHttpRequest());
        /** @type {?} */
        let sendable;
        if (typeof item._file.size !== 'number') {
            throw new TypeError('The file specified is no longer valid');
        }
        if (!this._options.disableMultipart) {
            sendable = new FormData();
            Object.keys(this._options.params || {}).forEach((/**
             * @param {?} key
             * @return {?}
             */
            (key) => sendable.append(key, (/** @type {?} */ (this._options.params))[key])));
            sendable.append(item.options.alias, item._file, item.file.name);
        }
        else {
            sendable = item._file;
        }
        xhr.upload.onprogress = (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            /** @type {?} */
            const progress = Math.round(event.lengthComputable ? (event.loaded * 100) / event.total : 0);
            this._onProgressItem(item, progress);
        });
        xhr.onload = (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            const headers = this._parseHeaders(xhr.getAllResponseHeaders());
            /** @type {?} */
            const response = this._transformResponse(xhr.response, headers);
            /** @type {?} */
            const gist = this._isSuccessCode(xhr.status) ? 'Success' : 'Error';
            /** @type {?} */
            const method = `_on${gist}Item`;
            ((/** @type {?} */ (this)))[method](item, response, xhr.status, headers);
            this._onCompleteItem(item, response, xhr.status, headers);
        });
        xhr.onerror = (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            const headers = this._parseHeaders(xhr.getAllResponseHeaders());
            /** @type {?} */
            const response = this._transformResponse(xhr.response, headers);
            this._onErrorItem(item, response, xhr.status, headers);
            this._onCompleteItem(item, response, xhr.status, headers);
        });
        xhr.onabort = (/**
         * @return {?}
         */
        () => {
            /** @type {?} */
            const headers = this._parseHeaders(xhr.getAllResponseHeaders());
            /** @type {?} */
            const response = this._transformResponse(xhr.response, headers);
            this._onCancelItem(item);
            this._onCompleteItem(item, response, xhr.status, headers);
        });
        xhr.open((/** @type {?} */ (item.options.method)), (/** @type {?} */ (item.options.url)), true);
        xhr.withCredentials = (/** @type {?} */ (item.options.withCredentials));
        if (item.options.headers && item.options.headers.length > 0) {
            for (const header of item.options.headers) {
                xhr.setRequestHeader(header.name, header.value);
            }
        }
        xhr.send(sendable);
        return this;
    }
    /**
     * @private
     * @param {?=} value
     * @return {?}
     */
    _getTotalProgress(value = 0) {
        if (this._options.removeAfterUpload) {
            return value;
        }
        /** @type {?} */
        const notUploaded = this.getNotUploadedItems().length;
        /** @type {?} */
        const uploaded = notUploaded ? this._queue.length - notUploaded : this._queue.length;
        /** @type {?} */
        const ratio = 100 / this._queue.length;
        /** @type {?} */
        const current = (value * ratio) / 100;
        return Math.round(uploaded * ratio + current);
    }
    /**
     * @private
     * @param {?} headers
     * @return {?}
     */
    _parseHeaders(headers) {
        /** @type {?} */
        const parsed = {};
        /** @type {?} */
        let key;
        /** @type {?} */
        let val;
        /** @type {?} */
        let i;
        if (!headers) {
            return parsed;
        }
        headers.split('\n').map((/**
         * @param {?} line
         * @return {?}
         */
        (line) => {
            i = line.indexOf(':');
            key = line.slice(0, i).trim().toLowerCase();
            val = line.slice(i + 1).trim();
            if (key) {
                parsed[key] = parsed[key] ? `${parsed[key]}, ${val}` : val;
            }
        }));
        return parsed;
    }
    /**
     * @private
     * @param {?} response
     * @param {?} _headers
     * @return {?}
     */
    _transformResponse(response, _headers) {
        return response;
    }
    /**
     * @private
     * @param {?} status
     * @return {?}
     */
    _isSuccessCode(status) {
        return (status >= 200 && status < 300) || status === 304;
    }
    /**
     * @private
     * @param {?} item
     * @param {?} progress
     * @return {?}
     */
    _onProgressItem(item, progress) {
        /** @type {?} */
        const total = this._getTotalProgress(progress);
        this._progress = total;
        item._onProgress(progress);
    }
    /**
     * @param {?} item
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onErrorItem(item, response, status, headers) {
        item._onError(response, status, headers);
    }
    /**
     * @private
     * @param {?} item
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onSuccessItem(item, response, status, headers) {
        item._onSuccess(response, status, headers);
    }
    /**
     * @private
     * @param {?} item
     * @return {?}
     */
    _onCancelItem(item) {
        item._onCancel();
    }
    /**
     * @param {?} item
     * @param {?} response
     * @param {?} status
     * @param {?} headers
     * @return {?}
     */
    _onCompleteItem(item, response, status, headers) {
        item._onComplete(response, status, headers);
        /** @type {?} */
        const nextItem = this.getReadyItems[0];
        this._isUploading = false;
        if (nextItem) {
            nextItem.upload();
            return;
        }
        this._progress = this._getTotalProgress();
        if (this._options.onFinished) {
            this._options.onFinished();
        }
    }
}
/** @nocollapse */
Uploader.ctorParameters = () => [
    { type: undefined },
    { type: UploaderConfig, decorators: [{ type: Inject, args: [UploaderConfig,] }, { type: Optional }] }
];
if (false) {
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._options;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._queue;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._progress;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._isUploading;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._nextIndex;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype._failFilterIndex;
    /**
     * @type {?}
     * @private
     */
    Uploader.prototype.globalConfig;
}

/**
 * @fileoverview added by tsickle
 * Generated from: uploader.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UploaderFileDirective {
    /**
     * @param {?} e
     * @return {?}
     */
    _onChange(e) {
        /** @type {?} */
        const hie = (/** @type {?} */ (e.target));
        this.uploader.addToQueue((/** @type {?} */ (((/** @type {?} */ ((/** @type {?} */ (hie.files))))))), this.uploader.options);
        if (!!((/** @type {?} */ (hie.attributes))).multiple) {
            hie.value = '';
        }
    }
}
UploaderFileDirective.decorators = [
    { type: Directive, args: [{
                selector: '[weui-uploader-file]',
                exportAs: 'weuiUploaderFile',
                host: {
                    '(change)': '_onChange($event)',
                },
            },] }
];
UploaderFileDirective.propDecorators = {
    uploader: [{ type: Input, args: ['weui-uploader-file',] }]
};
if (false) {
    /**
     * Uploader对象，必填项
     * @type {?}
     */
    UploaderFileDirective.prototype.uploader;
}

/**
 * @fileoverview added by tsickle
 * Generated from: file-thumb.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * 创建缩略图
 */
class FileThumbDirective {
    /**
     * @param {?} el
     */
    constructor(el) {
        this.el = el;
    }
    /**
     * @private
     * @return {?}
     */
    render() {
        if (!this.file) {
            return;
        }
        /** @type {?} */
        const url = genImageUrl(this.file);
        if (!url) {
            return;
        }
        this.el.nativeElement.style.backgroundImage = `url(${url})`;
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.render();
    }
}
FileThumbDirective.decorators = [
    { type: Directive, args: [{ selector: '[weui-thumb]' },] }
];
/** @nocollapse */
FileThumbDirective.ctorParameters = () => [
    { type: ElementRef }
];
FileThumbDirective.propDecorators = {
    file: [{ type: Input, args: ['weui-thumb',] }]
};
if (false) {
    /**
     * 文件对象，必填项
     * @type {?}
     */
    FileThumbDirective.prototype.file;
    /**
     * @type {?}
     * @private
     */
    FileThumbDirective.prototype.el;
}

/**
 * @fileoverview added by tsickle
 * Generated from: uploader.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UploaderModule {
}
UploaderModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [UploaderFileDirective, FileThumbDirective],
                exports: [UploaderFileDirective, FileThumbDirective],
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui-uploader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FileItem, FileLikeObject, FileThumbDirective, FileType, Uploader, UploaderConfig, UploaderFileDirective, UploaderModule };
//# sourceMappingURL=ngx-weui-uploader.js.map
