import { ElementRef, OnChanges, OnInit } from '@angular/core';
import { AbstractControl, ValidationErrors, Validator } from '@angular/forms';
/**
 * 文本框，指令是对文本框格式校验（邮箱、手机、身份证等）、视觉效果的增强而已
 */
export declare class InputDirective implements OnInit, OnChanges, Validator {
    private el;
    private parentEl;
    private ftEl;
    private _validator;
    private _onChange;
    /**
     * 文本框类型，**不等同于** <intpu type="text"> 的值
     * 因为 weui-input 属性只是内置格式校验的简洁写法而已。
     * 内置包括：number/digit(允许小数点)/qq/email/tel/mobile/idcard，如需要更为复杂的校验可以使用 weui-regex
     */
    inputType: string;
    /**
     * 格式校验正则表达式，优先级高于 [weui-input]。
     */
    inputRegex: RegExp | string;
    /**
     * 是否必填项，**等同于** <intpu required> 的值，当值必填时会有视觉效果
     */
    required: 'info' | 'warn' | 'waiting';
    /**
     * 是否自动清除内容中的空格
     */
    cleaner: boolean;
    constructor(el: ElementRef);
    ngOnInit(): void;
    ngOnChanges(): void;
    private _createValidator;
    registerOnValidatorChange(fn: () => void): void;
    validate(c: AbstractControl): ValidationErrors | null;
}
