import { EventEmitter } from '@angular/core';
/**
 * 数据对象
 */
export interface GalleryItem {
    /**
     * 远程网址
     */
    url?: string;
    /**
     * JavaScript File 对象
     */
    file?: File;
    /**
     * 文件标题
     */
    title?: string;
    /**
     * 是否允许删除，默认：`true`
     */
    canDelete?: boolean;
}
export declare class GalleryComponent {
    _imgs: any[];
    /**
     * 是否允许删除，默认：`true`
     */
    canDelete: boolean;
    /**
     * 删除回调
     */
    readonly delete: EventEmitter<any>;
    /**
     * 隐藏回调
     */
    readonly hide: EventEmitter<any>;
    /**
     * 标记是否显示，支持双向绑定
     */
    show: boolean;
    readonly showChange: EventEmitter<boolean>;
    _showd: boolean;
    /**
     * 图片数据
     *
     * - 虽然支持传递数组，但并不支持在打开后切换图片。
     */
    set imgs(val: string | File | string[] | GalleryItem[]);
    get _visibility(): string;
    _antStart(): void;
    _antDone(): void;
    _onDel(item: any): boolean;
    _onHide(): void;
    private parseImgs;
}
