import { ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { InfiniteLoaderConfig } from './infiniteloader.config';
export declare class InfiniteLoaderComponent implements OnInit, OnDestroy {
    private el;
    private DEF;
    private cdr;
    private didScroll;
    private scrollEvent;
    private scrollTime;
    private disposeScroller;
    _loading: boolean;
    _finished: boolean;
    _restart: boolean;
    private _config;
    readonly loadmore: EventEmitter<InfiniteLoaderComponent>;
    set config(val: InfiniteLoaderConfig);
    get config(): InfiniteLoaderConfig;
    constructor(el: ElementRef<HTMLElement>, DEF: InfiniteLoaderConfig, cdr: ChangeDetectorRef);
    /** 设置本次加载完成 */
    resolveLoading(): void;
    /** 设置结束 */
    setFinished(): void;
    /** 设置重新开始 */
    restart(): void;
    /**
     * 触发滚动
     */
    scroll(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
}
