import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
export declare class MaskComponent implements OnDestroy {
    private cdr;
    private observer;
    _shown: boolean;
    /**
     * 点击是否允许关闭（默认：`false`）
     */
    backdrop: boolean;
    /**
     * 内容方向（默认：`vertical`）
     * + `top`: 顶部居中
     * + `bottom`: 底部居中
     * + `vertical-left`: 垂直居左
     * + `vertical`: 垂直居中
     * + `vertical-right`: 垂直居右
     * + `none`: 无
     */
    placement: 'top' | 'bottom' | 'vertical' | 'vertical-left' | 'vertical-right' | 'none';
    /**
     * 内容背景色
     */
    bg: string;
    /**
     * 内容为Loading效果（默认：`false`）
     */
    loading: boolean;
    /**
     * 关闭回调
     */
    readonly close: EventEmitter<any>;
    constructor(cdr: ChangeDetectorRef);
    /**
     * 显示，并返回一个Observable
     */
    show(): Observable<void>;
    /**
     * 隐藏
     *
     * @param is_backdrop 是否手动点击关闭（默认：false）
     */
    hide(is_backdrop?: boolean): void;
    ngOnDestroy(): void;
}
