import { EventEmitter, OnChanges } from '@angular/core';
import { PaginationConfig } from './pagination.config';
import { PaginationMode } from './pagination.type';
export declare class PaginationComponent implements OnChanges {
    _ptArr: number[];
    _prevDisabled: boolean;
    _nextDisabled: boolean;
    /**
     * 形态，可选 `button`,`pointer`，默认：`button`
     */
    mode: PaginationMode;
    /** 当前索引 */
    current: number;
    /** 数据总数 */
    total: number;
    /**
     * 是否隐藏数值，默认：`false`
     */
    simple: boolean;
    /**
     * 小号按钮，默认：`true`
     */
    mini: boolean;
    /**
     * 上一页文本（支持HTML），默认：`上一页`
     */
    prevText: string;
    /**
     * 下一页文本（支持HTML），默认：`下一步`
     */
    nextText: string;
    /** 分页触发的回调函数 */
    readonly change: EventEmitter<number>;
    constructor(cog: PaginationConfig);
    ngOnChanges(): void;
    _checkDisabled(): void;
    _goto(value: number): void;
}
