import { ChangeDetectorRef, EventEmitter, Injector } from '@angular/core';
import { NwSafeAny } from 'ngx-weui/core';
import { PickerConfig } from './picker.config';
import { PickerGroupChange, PickerOptions } from './picker.types';
export declare class PickerBaseComponent {
    protected DEF: PickerConfig;
    protected injector: Injector;
    protected cdr: ChangeDetectorRef;
    /** 配置项 */
    options: PickerOptions;
    /** 当options.type=='form'时，占位符文本 */
    placeholder: string;
    title: string;
    disabled: boolean;
    /** 列变更时回调 */
    readonly groupChange: EventEmitter<PickerGroupChange>;
    /** 取消后回调 */
    readonly cancel: EventEmitter<any>;
    /** 显示时回调 */
    readonly show: EventEmitter<any>;
    /** 隐藏后回调 */
    readonly hide: EventEmitter<any>;
    constructor(DEF: PickerConfig, injector: Injector, cdr: ChangeDetectorRef);
    writeValue(_value: NwSafeAny): void;
}
