import { EventEmitter, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { PickerBaseComponent } from './picker-base.component';
import { PickerChangeData, PickerCityData, PickerCityDataMap, PickerGroupChange } from './picker.types';
/**
 * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
 */
export declare class CityPickerComponent extends PickerBaseComponent implements ControlValueAccessor, OnDestroy {
    set dataMap(val: PickerCityDataMap);
    set data(d: PickerCityData[]);
    private readonly pickerComp;
    readonly change: EventEmitter<PickerChangeData>;
    private _tmpData;
    private _dataMap;
    _value: string;
    _groups: PickerCityData[][] | null;
    _selected: number[];
    private onChange;
    private onTouched;
    private parseData;
    /**
     * 将值转换成位置
     */
    private valueToSelect;
    _onChange(data: PickerChangeData): void;
    _onGroupChange(res: PickerGroupChange): void;
    _onCityCancelChange(): void;
    /** 服务于Service，并无实际意义 */
    _triggerShow(): void;
    _onShow(): void;
    _onHide(): void;
    writeValue(value: string): void;
    registerOnChange(fn: (_: string) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    ngOnDestroy(): void;
}
