import { EventEmitter, OnChanges, OnInit, SimpleChange, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { NwSafeAny } from 'ngx-weui/core';
import { PickerBaseComponent } from './picker-base.component';
import { PickerChangeData, PickerData, PickerGroupChange } from './picker.types';
export declare class PickerComponent extends PickerBaseComponent implements ControlValueAccessor, OnInit, OnChanges {
    _showP: boolean;
    _shown: boolean;
    _value: NwSafeAny;
    _selected: number[];
    _groups: PickerData[][];
    _text: string;
    /**
     * 确认后回调当前选择数据（包括已选面板所有数据）
     */
    readonly change: EventEmitter<PickerChangeData>;
    /**
     * 当前默认位置，数组的长度必须等同于 groups 长度
     */
    set defaultSelect(d: number[]);
    /**
     * 多列数据，以数组的长度来决定几列数据
     * 支持string[]单列数组，单纯只是为了方便
     */
    set groups(d: PickerData[][] | string[]);
    private onChange;
    private onTouched;
    ngOnInit(): void;
    _onHide(fh: boolean): this;
    _onShow(): this;
    private parseOptions;
    private getSelecteItem;
    _setText(res?: PickerData[] | null): this;
    _setDefault(): this;
    _onGroupChange(data: PickerGroupChange, groupIndex: number): void;
    _onCancel(): boolean;
    _onConfirm(): boolean;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    writeValue(value: NwSafeAny): void;
    registerOnChange(fn: (_: NwSafeAny) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    _onFocus(ev: Event): void;
}
