import { ApplicationRef, ComponentFactoryResolver, Injector } from '@angular/core';
import { BaseService, NwSafeAny } from 'ngx-weui/core';
import { Observable } from 'rxjs';
import { PickerChangeData, PickerCityConfig, PickerCityData, PickerCityDataMap, PickerCreateConfig, PickerData, PickerDateChangeData, PickerDateFormatFullType, PickerDateTimeConfig, PickerDateType, PickerOptions } from './picker.types';
/**
 * 多列选择器Service，可直接通过Class构造选择器
 */
export declare class PickerService extends BaseService {
    protected readonly resolver: ComponentFactoryResolver;
    protected readonly applicationRef: ApplicationRef;
    protected readonly injector: Injector;
    protected readonly doc: any;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    private attachBase;
    create(config: PickerCreateConfig): Observable<PickerChangeData>;
    /**
     * @deprecated Use `create()` instead and going to be removed in 11.0.0
     *
     * 构建一个多列选择器并显示
     */
    show(data: PickerData[][] | string[], value?: NwSafeAny, defaultSelect?: number[], options?: PickerOptions): Observable<PickerChangeData>;
    /**
     * 构建一个城市选择器并显示
     */
    city(config: PickerCityConfig): Observable<PickerChangeData>;
    /**
     * @deprecated Use `city()` instead and going to be removed in 11.0.0
     *
     * 构建一个城市选择器并显示
     */
    showCity(data: PickerCityData[], value?: string, dataMap?: PickerCityDataMap, options?: PickerOptions): Observable<PickerChangeData>;
    /**
     * 构建一个日期时间选择器并显示
     */
    dateTime(config: PickerDateTimeConfig): Observable<PickerDateChangeData>;
    /**
     * @deprecated Use `dateTime()` instead and going to be removed in 11.0.0
     *
     * 构建一个日期时间选择器并显示
     */
    showDateTime(type?: PickerDateType, format?: PickerDateFormatFullType, value?: Date, min?: Date, max?: Date, options?: PickerOptions): Observable<PickerDateChangeData>;
}
