import { ChangeDetectorRef, EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { PopupConfig } from './popup.config';
export declare class PopupComponent implements OnDestroy {
    private DEF;
    private cdr;
    private observer;
    shown: boolean;
    _shownAnt: boolean;
    private _config;
    readonly cancel: EventEmitter<any>;
    readonly confirm: EventEmitter<any>;
    set config(val: PopupConfig);
    get config(): PopupConfig;
    get _visibility(): string;
    constructor(DEF: PopupConfig, cdr: ChangeDetectorRef);
    /**
     * 显示，并支持订阅结果，如果点击取消值为false，反之 true
     */
    show(): Observable<boolean>;
    /**
     * 隐藏
     *
     * @param [is_backdrop] 是否从背景上点击(可选)
     */
    hide(is_backdrop?: boolean): void;
    /** 关闭，等同 `hide()` 效果 */
    close(): void;
    _onCancel(): boolean;
    _onConfirm(): boolean;
    ngOnDestroy(): void;
}
