import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { SearchBarConfig } from './searchbar.config';
export declare class SearchBarComponent implements OnInit, OnDestroy {
    _q: string;
    /**
     * 占位符，默认：`搜索`
     */
    placeholder: string;
    /**
     * 取消按键文字，默认：`取消`
     */
    cancelText: string;
    /**
     * 去抖时长（单位：ms），默认：`300`
     */
    debounceTime: number;
    /** 搜索回调 */
    readonly search: EventEmitter<string>;
    /** 取消回调 */
    readonly cancel: EventEmitter<any>;
    /** 清空回调 */
    readonly clear: EventEmitter<any>;
    /** 提交回调（指的是键盘回车后） */
    readonly submit: EventEmitter<string>;
    _focus: boolean;
    private _term;
    private _sub;
    private _subject;
    set value(_value: string);
    constructor(DEF: SearchBarConfig);
    ngOnInit(): void;
    _doFocus(): void;
    _onBlur(): void;
    _onSearch(): void;
    _onCancel(): void;
    _onClear(): void;
    _onSubmit(e: any): boolean;
    ngOnDestroy(): void;
}
