import { EventEmitter, OnChanges, OnDestroy, SimpleChange, SimpleChanges } from '@angular/core';
import { ModeType, PositionType, SidebarConfig } from './sidebar.config';
import { SidebarService } from './sidebar.service';
/**
 * 侧边栏
 */
export declare class SidebarComponent implements OnChanges, OnDestroy {
    private _sidebarService;
    private doc;
    /**
     * 状态，true表示打开，false表示关闭
     */
    status: boolean;
    readonly statusChange: EventEmitter<boolean>;
    /**
     * 位置方向，默认：`left`
     */
    position: PositionType;
    /**
     * 类型，默认：`slide`
     * - over: 不覆盖
     * - slide：侧边移动
     */
    mode: ModeType;
    /**
     * 允许点击背景关闭，默认：`true`
     */
    backdrop: boolean;
    /**
     * 自定义CLSS
     */
    sidebarClass: string;
    /**
     * 辅助设备标识
     */
    ariaLabel: string;
    /** 打开前回调 */
    readonly openStart: EventEmitter<null>;
    /** 打开后回调 */
    readonly opened: EventEmitter<null>;
    /** 关闭前回调 */
    readonly closeStart: EventEmitter<null>;
    /** 关闭后回调 */
    readonly closed: EventEmitter<null>;
    /** 模式变更通知 */
    readonly modeChange: EventEmitter<string>;
    /** 位置变更通知 */
    readonly positionChange: EventEmitter<string>;
    readonly _rerender: EventEmitter<null>;
    private _elSidebar;
    private _openSub;
    private _closeSub;
    private _clickEvent;
    private _onClickOutsideAttached;
    private _anting;
    /** 获取侧边栏容器高度 */
    get _height(): number;
    /** 获取侧边栏容器宽度 */
    get _width(): number;
    constructor(_sidebarService: SidebarService, config: SidebarConfig, doc: any);
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    ngOnDestroy(): void;
    /** 打开侧边栏 */
    open(): void;
    /** 关闭侧边栏 */
    close(): void;
    /** 手动触发容器的重新渲染 */
    _triggerRerender(): void;
    _getStyle(): CSSStyleDeclaration;
    private closeAnt;
    private _initCloseListeners;
    private _destroyCloseListeners;
    private _onClickOutside;
}
