import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
export declare class SliderComponent implements ControlValueAccessor, AfterViewInit, OnDestroy, OnChanges {
    private cdr;
    private el;
    private state;
    private isInit;
    private trackEl;
    private handlerEl;
    private onChange;
    private onTouched;
    private onTouchStart;
    private onTouchMove;
    value: number;
    /**
     * 允许的最小值，默认：`0`
     */
    min: number;
    /**
     * 允许的最大值，默认：`100`
     */
    max: number;
    /**
     * 步长，默认：`1`
     */
    step: number;
    /**
     * 是否可用
     */
    enabled: boolean;
    showValue: boolean;
    /**
     * 值改变时触发
     */
    readonly change: EventEmitter<number>;
    constructor(el: ElementRef<HTMLElement>, cdr: ChangeDetectorRef);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    private refresh;
    private setValue;
    private layout;
    private startHandle;
    private moveHandle;
    private getPercentage;
    private calculateValue;
    ngOnChanges(): void;
    writeValue(value: number): void;
    registerOnChange(fn: (_: number) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
}
