import { ChangeDetectorRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
/**
 * Stepper 步进器，支持 `[(ngModel)]`
 */
export declare class StepperComponent implements ControlValueAccessor {
    private cdr;
    private _value;
    private onChange;
    _step: number;
    _precisionStep: number;
    _precisionFactor: number;
    _disabledMinus: boolean;
    _disabledPlus: boolean;
    /** 最小值 */
    min: number;
    /** 最大值 */
    max: number;
    /** 禁用 */
    disabled: boolean;
    /** 变更时回调 */
    readonly change: EventEmitter<number>;
    private _inputNumber;
    /** 步长，可以为小数 */
    get step(): number;
    set step(value: number);
    get value(): number;
    set value(value: number);
    constructor(cdr: ChangeDetectorRef);
    _checkDisabled(): this;
    _notify(): void;
    _plus(): void;
    _minus(): void;
    _blur(): void;
    _toPrecisionAsStep(num: any): number;
    writeValue(value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(_fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
}
