import { ApplicationRef, ComponentFactoryResolver, Injector } from '@angular/core';
import { BaseService } from 'ngx-weui/core';
import { ToastComponent } from './toast.component';
export declare class ToastService extends BaseService {
    protected readonly resolver: ComponentFactoryResolver;
    protected readonly applicationRef: ApplicationRef;
    protected readonly injector: Injector;
    protected readonly doc: any;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    /**
     * 构建toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms），0 表示永久（可选）
     * @param [icon] icon图标Class名（可选）
     * @param [type] 类型（可选）
     */
    show(text?: string, time?: number, icon?: string, type?: 'success' | 'loading'): ToastComponent;
    /**
     * 关闭最新toast
     */
    hide(): void;
    /**
     * 构建成功toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms）（可选）
     * @param [icon] icon图标Class名（可选）
     */
    success(text?: string, time?: number, icon?: string): ToastComponent;
    /**
     * 构建加载中toast并显示
     *
     * @param [text] 文本（可选）
     * @param [time] 显示时长后自动关闭（单位：ms）（可选）
     * @param [icon] icon图标Class名（可选）
     */
    loading(text?: string, time?: number, icon?: string): ToastComponent;
}
