import { ApplicationRef, ComponentFactoryResolver, Injector } from '@angular/core';
import { BaseService } from 'ngx-weui/core';
import { ToptipsComponent, ToptipsType } from './toptips.component';
export declare class ToptipsService extends BaseService {
    protected readonly resolver: ComponentFactoryResolver;
    protected readonly applicationRef: ApplicationRef;
    protected readonly injector: Injector;
    protected readonly doc: any;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    /**
     * 构建一个Toptips并显示
     *
     * @param text 文本
     * @param type 类型
     * @param 显示时长后自动关闭（单位：ms）
     */
    show(text: string, type: ToptipsType, time?: number): ToptipsComponent;
    /**
     * 构建一个Warn Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    warn(text: string, time?: number): ToptipsComponent;
    /**
     * 构建一个Info Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    info(text: string, time?: number): ToptipsComponent;
    /**
     * 构建一个Primary Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    primary(text: string, time?: number): ToptipsComponent;
    /**
     * 构建一个Success Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    success(text: string, time?: number): ToptipsComponent;
    /**
     * 构建一个Default Toptips并显示
     *
     * @param text 文本
     * @param time 显示时长后自动关闭（单位：ms）
     */
    default(text: string, time?: number): ToptipsComponent;
}
